=== modified file '.bzrignore'
--- .bzrignore	2012-08-24 20:08:54 +0000
+++ .bzrignore	2012-09-07 14:35:08 +0000
@@ -6,3 +6,4 @@
 app/assets/javascripts/d3.v2.js
 app/assets/javascripts/d3.v2.min.js
 app/assets/javascripts/yui
+*~

=== modified file 'Makefile'
--- Makefile	2012-08-27 15:28:03 +0000
+++ Makefile	2012-09-07 20:45:25 +0000
@@ -7,12 +7,14 @@
 	@ln -sf `pwd`/node_modules/d3/d3.v2* ./app/assets/javascripts/
 	@./bin/generateTemplates
 
+lint: install
+	@node_modules/jshint/bin/hint --config=jshint.config `bzr ls -RV -k file | grep -v assets/ | grep -v app/templates.js`
 
 test: install 
-	@gnome-open test/index.html
+	@xdg-open test/index.html
 
-server: install 
+server: install
 	@echo "Customize config.js to modify server settings"
 	@node server.js
 
-.PHONY: test
+.PHONY: test lint server

=== renamed file 'readme' => 'README'
--- readme	2012-09-03 08:53:33 +0000
+++ README	2012-09-07 18:19:34 +0000
@@ -1,7 +1,3 @@
-
-
-
-
 Developer Install
 -----------------
 
@@ -13,6 +9,14 @@
 sudo apt-get update
 sudo apt-get install nodejs npm
 
+ The linter will be installed locally per branch, but if you want editor
+ integration, you may want to install jshint globally in your system.
+
+sudo npm install -g jshint
+
+ For building the docs, you also need sphinx.
+
+sudo apt-get install python-sphinx
 
  The gui frontend can be installed with::
 
@@ -54,9 +58,15 @@
   After which the gui should be functional (it automatically polls the 
   api server for establishing a websocket).
  
-
    
 Running unit tests.
 -------------------
 
- gnome-open tests/index.html
\ No newline at end of file
+ xdg-open test/index.html
+
+
+Running lint
+------------
+
+ jshint --config=jshint.config `bzr ls -RV -k file | grep -v assets/`
+ 
\ No newline at end of file

=== modified file 'app/app.js'
--- app/app.js	2012-09-07 15:58:58 +0000
+++ app/app.js	2012-09-10 08:45:43 +0000
@@ -1,12 +1,17 @@
+"use strict";
+
+// Create a global for debug console access to YUI context.
+var yui;
+
 YUI.add("juju-gui", function(Y) {
 
-// Debug console access to YUI context.
+// Assign the global for console access.
 yui = Y;
 
 var juju = Y.namespace('juju');
 var models = Y.namespace("juju.models");
 
-JujuGUI = Y.Base.create("juju-gui", Y.App, [], {
+var JujuGUI = Y.Base.create("juju-gui", Y.App, [], {
     views: {
         environment: {
             type: "juju.views.environment",
@@ -125,7 +130,7 @@
 
     navigate_to_charm_collection: function(e) {
         console.log("Evt.Nav.Router charm collection");
-        query = Y.one('#charm-search').get('value');
+        var query = Y.one('#charm-search').get('value');
         this.navigate("/charms/?q=" + query);
     },
 
@@ -278,7 +283,7 @@
     ATTRS: {
         routes: {
             value: [
-		{path: "*", callback: 'show_charm_search'},
+                {path: "*", callback: 'show_charm_search'},
 
                 {path: "/charms/", callback: 'show_charm_collection'},
                 {path: "/charms/*charm_url", callback: 'show_charm'},
@@ -297,13 +302,13 @@
 
 }, "0.5.2", {
     requires: [
-	"juju-models",
-	"juju-views",
-	"juju-controllers",
-	"io",
-	"json-parse",
-	'app-base',
-	'app-transitions',
-	'base',
-	'node']
+        "juju-models",
+        "juju-views",
+        "juju-controllers",
+        "io",
+        "json-parse",
+        'app-base',
+        'app-transitions',
+        'base',
+        'node']
 });

=== modified file 'app/assets/javascripts/svg-layouts.js'
--- app/assets/javascripts/svg-layouts.js	2012-08-04 13:21:26 +0000
+++ app/assets/javascripts/svg-layouts.js	2012-09-07 13:29:55 +0000
@@ -9,7 +9,7 @@
         }
         return rect;
     });
-            
+
 }, "0.0.1", {
     requires: ["node"]
 });

=== modified file 'app/assets/stylesheets/juju-gui.css'
--- app/assets/stylesheets/juju-gui.css	2012-09-01 01:45:08 +0000
+++ app/assets/stylesheets/juju-gui.css	2012-09-07 15:38:58 +0000
@@ -5,11 +5,14 @@
 .state-error{stroke:#FF0000;}
 .state-started{stroke:#000000;}
 .state-pending{stroke:#6597E8;}
-g.service .charm-label{font-size:0.7em;fill:#333333;}
+g.service{fill:#f5f5f5;stroke:black;}g.service .charm-label{font-size:0.7em;fill:#333333;}
 g.service .name{font-weight:bold;font-family:"Ubuntu";font-size:1.6em;fill:#333333;}
 g.service .service-border{stroke-width:2px;}
-g.service .unit-count{stroke:#000000;stroke-width:1px;font-family:"Ubuntu";fill:#333333;font-size:2.5em;}
-g.service{fill:#f5f5f5;stroke:black;}
-g.unit .address{fill:#ffffff;font-size:0.8em;}
+g.service .unit-count{stroke-width:0;text-anchor:middle;dominant-baseline:central;fill:rgba(0, 0, 0, 0);font-family:"Ubuntu";font-size:2.5em;}g.service .unit-count.show-count{fill:#000000;}
+g.service .unit-count.hide-count{fill:rgba(0, 0, 0, 0);}
+g.service-status path{stroke-width:0;}g.service-status path.status-pending{fill:#fcd305;}
+g.service-status path.status-started{fill:#b7b7b7;}
+g.service-status path.status-installed{fill:#ffffff;}
+g.service-status path.status-error{fill:#c01c20;}
+g.unit{stroke-width:0;font-weight:bold;font-family:"Ubuntu";font-size:1.2em;fill:#1626cf;}g.unit .address{fill:#ffffff;font-size:0.8em;}
 g.unit .unit-border{stroke-width:2px;fill:#a0a0a0;}
-g.unit{stroke-width:0;font-weight:bold;font-family:"Ubuntu";font-size:1.2em;fill:#1626cf;}

=== added file 'app/config.js'
--- app/config.js	1970-01-01 00:00:00 +0000
+++ app/config.js	2012-09-10 08:45:43 +0000
@@ -0,0 +1,11 @@
+juju_config = {
+    serverRouting: false,
+    html5: true,
+    container: "#main",
+    viewContainer: "#main",
+    // FIXME: turn off transitions until they are fixed.
+    transitions: false,
+    charm_store: new Y.DataSource.IO({source: 'http://jujucharms.com/'}),
+    socket_url: "ws://localhost:8081/ws"
+};
+

=== modified file 'app/index.html'
--- app/index.html	2012-09-07 15:58:58 +0000
+++ app/index.html	2012-09-10 08:45:43 +0000
@@ -2,7 +2,6 @@
 <html>
   <head>
     <meta charset="utf-8">
-    <!-- GENERATED FROM lib/views/index.handlebars -->
     <title>Juju Admin</title>
     <meta name="viewport" content="width=device-width,initial-scale=1.0">
     <meta name="description" content="">
@@ -44,19 +43,10 @@
     <!-- javascript away -->
     <script src="/assets/javascripts/yui/yui/yui-debug.js"></script>
     <script src="/modules.js"></script>
+    <script src="/config.js"></script>
     <script>
-      YUI(GlobalConfig).use("juju-gui", function(Y) {
-      app = new Y.juju.App({
-              serverRouting: false,
-              html5: true,
-              socket_url: 'ws://localhost:8081/ws',
-              contain : "#main",
-              viewContainer: "#main",
-              // FIXME: turn off transitions until they are fixed.
-              transitions: false,
-              charm_store: new Y.DataSource.IO({
-                  source: 'http://jujucharms.com/'})
-          });
+      YUI(GlobalConfig).use(["juju-gui"], function(Y) {
+        app = new Y.juju.App(juju_config);
       });
     </script>
   </body>

=== modified file 'app/models/models.js'
--- app/models/models.js	2012-09-01 19:09:39 +0000
+++ app/models/models.js	2012-09-07 20:29:04 +0000
@@ -1,3 +1,5 @@
+"use strict";
+
 YUI.add("juju-models", function(Y) {
 
 var models = Y.namespace("juju.models");
@@ -11,8 +13,8 @@
         }
     }, {
     ATTRS: {
-	charm_id: {},
-	name: {
+        charm_id: {},
+        name: {
             valueFn: function(name) {
                 var match = this.parse_charm_id();
                 if (match) {
@@ -20,11 +22,11 @@
                 }
             }
         },
-	url: {},
-	description: {},
-	config: {},
-	metadata: {},
-	sha256: {}
+        url: {},
+        description: {},
+        config: {},
+        metadata: {},
+        sha256: {}
     }
 });
 models.Charm = Charm;
@@ -39,29 +41,23 @@
 
 
 
-Service = Y.Base.create('service', Y.Model, [], {
+var Service = Y.Base.create('service', Y.Model, [], {
 //    idAttribute: 'name',
 
-    get_unit_agent_states: function() {
-        // return an object with keys set to each unique agent state
-        // in this services units
-        // XXX: for this to work we need access to the units
-        // of this service, this either creates a dep on the
-        // apps data store or requires explicit binding at
-        // creation
-    },
     ATTRS: {
-	name: {},
-	charm: {},
-	config: {},
-	constraints: {},
-	exposed: {value: false},
-	relations: {}
+        name: {},
+        charm: {},
+        config: {},
+        constraints: {},
+        exposed: {value: false},
+        relations: {},
+        unit_count: {},
+        aggregated_status: {}
     }
 });
 models.Service = Service;
 
-ServiceList = Y.Base.create('serviceList', Y.ModelList, [], {
+var ServiceList = Y.Base.create('serviceList', Y.ModelList, [], {
     model: Service
     }, {
     ATTRS: {
@@ -69,33 +65,33 @@
 });
 models.ServiceList = ServiceList;
 
-ServiceUnit = Y.Base.create('serviceUnit', Y.Model, [], {},
+var ServiceUnit = Y.Base.create('serviceUnit', Y.Model, [], {},
 //    idAttribute: 'name',
     {
     ATTRS: {
-	service: {
+        service: {
             valueFn: function(name) {
                 var unit_name = this.get("id");
                 return unit_name.split("/", 1)[0];
             }
         },
-	machine: {},
-	agent_state: {},
-	// relations to unit relation state.
-	relations: {},
-	
-	config: {},
-	is_subordinate: {
+        machine: {},
+        agent_state: {},
+        // relations to unit relation state.
+        relations: {},
+
+        config: {},
+        is_subordinate: {
             value: false // default
         },
-	open_ports: {},
-	public_address: {},
-	private_address: {}
+        open_ports: {},
+        public_address: {},
+        private_address: {}
     }
 });
 models.ServiceUnit = ServiceUnit;
 
-ServiceUnitList = Y.Base.create('serviceUnitList', Y.ModelList, [], {
+var ServiceUnitList = Y.Base.create('serviceUnitList', Y.ModelList, [], {
     model: ServiceUnit,
     get_units_for_service: function(service, asList) {
         var options = {},
@@ -104,41 +100,76 @@
         if (asList !== undefined) {
             options.asList = true;
         }
-        
+
         var units = this.filter(options, function(m) {
             return m.get("service") == sid;
         });
         return units;
     },
     /*
-     *  Return information about the state of all units focused on the 
-     * 'worst' status information available. In this way if any unit is in 
+     *  Return information about the state of all units focused on the
+     * 'worst' status information available. In this way if any unit is in
      *  an error state we can report that for the whole list.
      *
-     * KT - Should return an aggregate count by state (map), so proproptional 
+     * KT - Should return an aggregate count by state (map), so proproptional
      * representation can be done in various renderings.
      */
     get_informative_state: function() {
     },
+    /*
+     *  Return information about the state of the set of units for a
+     *  given service in the form of a map of agent states:
+     *  state => number of units in that state
+     */
+    get_informative_states_for_service: function(service) {
+        var aggregate_map = {}, aggregate_list = [],
+            units_for_service = this.get_units_for_service(service);
+
+        units_for_service.forEach(function(unit) {
+            var state = unit.get('agent_state');
+            if (aggregate_map[state] === undefined) {
+                aggregate_map[state] = 1;
+            } else {
+                aggregate_map[state]++;
+            }
+
+        });
+
+        return aggregate_map;
+    },
+
+    /*
+     * Updates a service's unit count and aggregate state map during a
+     * delta, ensuring that they're up to date.
+     */
+    update_service_unit_aggregates: function(service) {
+        var aggregate = this.get_informative_states_for_service(service);
+        var sum = 0;
+        for (var agent_state in aggregate) {
+            sum += aggregate[agent_state];
+        }
+        service.set("unit_count", sum);
+        service.set("aggregated_status", aggregate);
+    },
     ATTRS: {
     }
 });
 models.ServiceUnitList = ServiceUnitList;
 
-Machine = Y.Base.create('machine', Y.Model, [], {
+var Machine = Y.Base.create('machine', Y.Model, [], {
     idAttribute: 'machine_id'
     }, {
     ATTRS: {
-	machine_id: {},
-	public_address: {},
-	instance_id: {},
+        machine_id: {},
+        public_address: {},
+        instance_id: {},
     instance_state: {},
     agent_state: {}
     }
 });
 models.Machine = Machine;
 
-MachineList = Y.Base.create('machineList', Y.ModelList, [], {
+var MachineList = Y.Base.create('machineList', Y.ModelList, [], {
     model: Machine
     }, {
     ATTRS: {
@@ -146,25 +177,25 @@
 });
 models.MachineList = MachineList;
 
-Relation = Y.Base.create('relation', Y.Model, [], {
+var Relation = Y.Base.create('relation', Y.Model, [], {
     idAttribute: 'relation_id'
     }, {
     ATTRS: {
-	relation_id: {},
-	type: {},
-	endpoints: {}
+        relation_id: {},
+        type: {},
+        endpoints: {}
     }
 });
 models.Relation = Relation;
 
-RelationList = Y.Base.create('relationList', Y.ModelList, [], {}, {
+var RelationList = Y.Base.create('relationList', Y.ModelList, [], {}, {
     ATTRS: {
     }
 });
 models.RelationList = RelationList;
 
-    
-Database = Y.Base.create('database', Y.Base, [], {
+
+var Database = Y.Base.create('database', Y.Base, [], {
     initializer: function() {
         this.services = new ServiceList();
         this.machines = new MachineList();
@@ -202,7 +233,7 @@
     on_delta: function(delta_evt) {
         var changes = delta_evt.data.result;
         console.log("Delta", this, changes);
-        var change_type, model_class = null;
+        var change_type, model_class = null, self = this;
 
         changes.forEach(
             Y.bind(function(change) {
@@ -216,6 +247,9 @@
                 var model_list = this[change_type + 's'];
                 this.process_model_delta(change, model_class, model_list);
             }, this));
+        this.services.each(function(service) {
+            self.units.update_service_unit_aggregates(service);
+        });
         this.fire('update');
     },
 
@@ -224,30 +258,31 @@
         // TODO: need to bulk mutate and then send mutation event,
         // as is this is doing per attribute events.
         for (var vid in bag) {
-            value = bag[vid];
-            aid = vid.replace('-', "_");
+            var value = bag[vid];
+            var aid = vid.replace('-', "_");
             if (model.get(aid) != value) {
                 model.set(aid, value);
             }
         }
     },
 
-    process_model_delta: function(change, model_class, model_list) {
+    process_model_delta: function(change, ModelClass, model_list) {
         // console.log('model change', change);
         var change_kind = change[1];
         var data = change[2];
+        var o;
         if (change_kind == 'add') {
-            o = new model_class({id: data['id']});
+            o = new ModelClass({id: data.id});
             this._sync_bag(data, o);
             model_list.add(o);
         } else if (change_kind == 'delete') {
             model_list.remove(model_list.getById(data));
         } else if (change_kind == 'change') {
-            o = model_list.getById(data['id']);
+            o = model_list.getById(data.id);
             this._sync_bag(data, o);
         }
     }
- 
+
 });
 
 models.Database = Database;
@@ -260,4 +295,4 @@
         "model-list",
         "lazy-model-list"
     ]
-});
\ No newline at end of file
+});

=== modified file 'app/modules.js'
--- app/modules.js	2012-08-28 17:36:17 +0000
+++ app/modules.js	2012-09-07 18:31:30 +0000
@@ -18,7 +18,7 @@
         },
         juju: {
             modules: {
-		// Primitives
+                // Primitives
 
                 "svg-layouts" : {
                     fullpath: "/assets/javascripts/svg-layouts.js"
@@ -28,11 +28,11 @@
                     fullpath: "/assets/javascripts/reconnecting-websocket.js"
                 },
 
-		// Views
+                // Views
                 "juju-view-utils": {
                     fullpath: "/views/utils.js"
                 },
-                    
+
                 "juju-view-environment": {
                     fullpath: "/views/environment.js"
                 },
@@ -56,7 +56,7 @@
                 "juju-view-charm": {
                     fullpath: "/views/charm.js"
                 },
-                        
+
                 "juju-templates": {
                   fullpath: "/templates.js"
                 },
@@ -65,22 +65,22 @@
                     use: [
                           "juju-templates",
                           "juju-view-utils",
-                          "juju-view-environment", 
-			  "juju-view-service", 
-			  "juju-view-unit",
-			  "juju-view-charmsearch",
-			  "juju-view-charm",
-			  "juju-view-charm-collection"]
+                          "juju-view-environment",
+                          "juju-view-service",
+                          "juju-view-unit",
+                          "juju-view-charmsearch",
+                          "juju-view-charm",
+                          "juju-view-charm-collection"]
                 },
-		
-		// Models
+
+                // Models
 
                 "juju-models": {
                     requires: ["model", "model-list"],
                     fullpath: "/models/models.js"
                 },
 
-		// Connectivity		
+                // Connectivity
                 "juju-env": {
                     requires: ["reconnecting-websocket"],
                     fullpath: "/store/env.js"
@@ -89,20 +89,19 @@
                 "juju-charm-store": {
                     fullpath: "/store/charm.js"
                 },
-		
-
-		"juju-controllers": {
-		    use: ["juju-env", "juju-charm-store"]
+
+
+                "juju-controllers": {
+                    use: ["juju-env", "juju-charm-store"]
                 },
 
-		// App
+                // App
                 "juju-gui": {
                     fullpath: "/app.js",
                     requires: [
-			"juju-controllers",
+                        "juju-controllers",
                         "juju-views",
                         "juju-models"
-//                        "svg-layouts"
                     ]
                 }
             }

=== modified file 'app/store/charm.js'
--- app/store/charm.js	2012-08-16 00:48:16 +0000
+++ app/store/charm.js	2012-09-07 15:14:54 +0000
@@ -1,14 +1,16 @@
+"use strict";
+
 YUI.add("juju-charm-store", function(Y) {
-    
+
 
 //
 
 }, "0.1.0", {
     requires: [
-	"io",
-	"datasource-io",
-	"datasource-jsonschema",
-	"datasource-cache",
-//	"json-parse",
-	]
-});
\ No newline at end of file
+        "io",
+        "datasource-io",
+        "datasource-jsonschema",
+        "datasource-cache"
+//      "json-parse",
+        ]
+});

=== modified file 'app/store/env.js'
--- app/store/env.js	2012-08-28 17:36:17 +0000
+++ app/store/env.js	2012-09-07 15:14:54 +0000
@@ -1,3 +1,5 @@
+"use strict";
+
 YUI.add("juju-env", function(Y) {
 
 function Environment(config) {
@@ -96,7 +98,7 @@
 
     _dispatch_rpc_result: function(msg){
         if ('request_id' in msg) {
-            var tid = msg['request_id'];
+            var tid = msg.request_id;
             if (tid in this._txn_callbacks) {
                 console.log('Env: Dispatch Rpc');
                 this._txn_callbacks[tid].apply(this, [msg]);
@@ -130,7 +132,7 @@
             'op': 'add_relation',
             'endpoint_a': endpoint_a,
             'endpoint_b': endpoint_b}, callback);
-        
+
     },
 
     get_charm: function(charm_url, callback) {
@@ -162,9 +164,8 @@
 
     destroy_service: function(service, callback) {
         this._send_rpc({
-            'op': 'remove_relation',
-            'endpoint_a': endpoint_a,
-            'endpoint_b': endpoint_b}, callback);
+            'op': 'destroy_service',
+            'service': service}, callback);
     }
 
 });

=== modified file 'app/templates.js'
--- app/templates.js	2012-09-01 01:45:08 +0000
+++ app/templates.js	2012-09-07 20:19:19 +0000
@@ -1,11 +1,116 @@
 /*
  * Generated code -- lib/views/templates.handlebars
-*/
+ */
 YUI.add('juju-templates', function (Y) {
 
     var Templates = Y.namespace('juju.views').Templates = {};
 
   
+    Templates['overview'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
+  helpers = helpers || Handlebars.helpers;
+  
+
+
+  return "<div id=\"canvas\"></div>\n";});
+  
+    Templates['charm-collection'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
+  helpers = helpers || Handlebars.helpers;
+  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
+
+function program1(depth0,data) {
+  
+  var buffer = "", stack1, foundHelper;
+  buffer += "\n              <li class=\"span3\">\n		<div class=\"thumbnail\" data-charm-url=\"";
+  foundHelper = helpers.data_url;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.data_url; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "\">\n		  <h5>~";
+  foundHelper = helpers.owner;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.owner; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "/";
+  foundHelper = helpers.series;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.series; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "/";
+  foundHelper = helpers.name;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + " <i class=\"icon-user\"></i></h5>\n		  <span>";
+  foundHelper = helpers.summary;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.summary; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "</span>\n		</div>\n	      </li>\n              ";
+  return buffer;}
+
+  buffer += "      <div>\n        <h1>Charm Collection</h1>\n	<form class=\"well form-inline\">\n	  <label>Series <input type=\"text\" class=\"input-small\" placeholder=\"Precise\"></label>\n	  <label>Owner <input type=\"text\" class=\"input-small\" placeholder=\"Ubuntu\"></label>\n	  <label>Provides <input type=\"text\" class=\"input-small\" placeholder=\"Owner\"></label>\n	  <label>Requires <input type=\"text\" class=\"input-small\" placeholder=\"Owner\"></label>\n	  <label>\n	    Sort \n	    <select class=\"input-small\">\n	      <option>Match</option>\n	      <option>Modified</option>\n	      <option>Owner</option>\n	      <option>Series</option>\n	    </select>\n	  </label>\n	  <button type=\"submit\" class=\"btn\">Search</button>\n	</form>\n	<div class=\"collection\">\n	  <div class=\"charm\">\n	    <ul class=\"thumbnails\">\n              ";
+  foundHelper = helpers.charms;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
+  else { stack1 = depth0.charms; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  if (!helpers.charms) { stack1 = blockHelperMissing.call(depth0, stack1, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
+  if(stack1 || stack1 === 0) { buffer += stack1; }
+  buffer += "\n	    </ul>\n	  </div>\n	</div>\n      </div>\n";
+  return buffer;});
+  
+    Templates['service'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
+  helpers = helpers || Handlebars.helpers;
+  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
+
+function program1(depth0,data) {
+  
+  var buffer = "", stack1, foundHelper;
+  buffer += "\n	    <li class=\"span3\">\n	      <div class=\"thumbnail well\" id=\"";
+  foundHelper = helpers.id;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.id; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "\">\n		<h5>";
+  foundHelper = helpers.id;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.id; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "</h5>\n		<span>";
+  foundHelper = helpers.agent_state;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.agent_state; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "</span> <br/>\n		<span>";
+  foundHelper = helpers.public_address;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.public_address; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "</span>\n	      </div>\n	    </li>\n	    ";
+  return buffer;}
+
+  buffer += " <div class=\"row\">\n	<div class=\"span8\">\n	  <h1><a href=\"/service/";
+  stack1 = depth0.service;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "/\"> Service ";
+  stack1 = depth0.service;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "</a></h1>\n	  <br/> <br/>\n    <div class=\"btn-group\">\n      <a href=\".\" class=\"btn\"><i class=\"icon-th\"></i> Units </a>\n      <a href=\"config\" class=\"btn\"><i class=\"icon-cog\"></i> Settings </a>\n      <a href=\"constraints\" class=\"btn\"><i class=\"icon-leaf\"></i> Constraints</a>\n      <a href=\"/charms/charms/";
+  stack1 = depth0.charm;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "/json\"\n         class=\"btn\"><i class=\"icon-book\"></i> Charm </a>\n      <button class=\"btn\"><i class=\"icon-ban-circle\"></i> Exposed </button>\n      <a href=\"relations\" class=\"btn\"><i class=\"icon-random\"></i> Relations </a>\n    </div>\n	</div>\n	<div class=\"span4\">\n	  <div class=\"well\">\n	    <span>\n	      <b>Charm:</b>\n	      <a href=\"/charms/charms/";
+  stack1 = depth0.charm;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "/json\">";
+  stack1 = depth0.charm;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "</a></span>\n	    <br/>\n	    <span> <b>Units:</b></span>\n	    <br/>\n	    <span> <b>Relations:</b></span>\n	    <br/>\n	    <span><b>Exposed:</b> ";
+  stack1 = depth0.service;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.exposed;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "</span>\n	    <br/>\n	  </div>\n	</div>\n </div>\n\n <div class=\"row\">\n	<div class=\"span12\">\n	  <ul class=\"nav nav-tabs\">\n	    <li class=\"active\"><a href=\".\">All</a></li>\n	    <li><a href=\"?state=running\">Running</a></li>\n	    <li><a href=\"?state=pending\">Pending</a></li>\n	    <li><a href=\"?state=error\">Error</a></li>\n	  </ul>\n	</div>\n </div>\n\n\n <div class=\"collection\">\n	<div class=\"charm\">\n	  <ul class=\"thumbnails\">\n	    ";
+  foundHelper = helpers.units;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
+  else { stack1 = depth0.units; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  if (!helpers.units) { stack1 = blockHelperMissing.call(depth0, stack1, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
+  if(stack1 || stack1 === 0) { buffer += stack1; }
+  buffer += "	    \n	  </ul>\n	</div>\n </div>\n\n";
+  return buffer;});
+  
     Templates['unit'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
   helpers = helpers || Handlebars.helpers;
   var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
@@ -65,6 +170,77 @@
   buffer += "      \n      </ul>\n    </div>\n </div>\n\n";
   return buffer;});
   
+    Templates['service-config'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
+  helpers = helpers || Handlebars.helpers;
+  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
+
+function program1(depth0,data) {
+  
+  var buffer = "", stack1, foundHelper;
+  buffer += "\n\n        <div class=\"control-group\">\n          <div class=\"well\">\n            ";
+  foundHelper = helpers.description;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.description; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "\n          </div>\n          <div class=\"control-label\" for=\"";
+  foundHelper = helpers.name;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "\">";
+  foundHelper = helpers.type;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.type; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + ": ";
+  foundHelper = helpers.name;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "</div>\n          <div class=\"controls\">\n             <input type=\"text\" id=\"input-";
+  foundHelper = helpers.name;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "\" value=\"";
+  foundHelper = helpers.value;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
+  else { stack1 = depth0.value; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  buffer += escapeExpression(stack1) + "\"/>\n          </div>          \n        </div>\n \n      ";
+  return buffer;}
+
+  buffer += "<div class=\"row\">\n  <div class=\"span8\">\n    <h1><a href=\"/service/";
+  stack1 = depth0.service;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "/\"> Service ";
+  stack1 = depth0.service;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "</a></h1>\n    <br/> <br/>\n    <div class=\"btn-group\">\n      <a href=\".\" class=\"btn\"><i class=\"icon-th\"></i> Units </a>\n      <a href=\"config\" class=\"btn\"><i class=\"icon-cog\"></i> Settings </a>\n      <a href=\"constraints\" class=\"btn\"><i class=\"icon-leaf\"></i> Constraints</a>\n      <a href=\"/charms/charms/";
+  stack1 = depth0.charm;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "/json\"\n         class=\"btn\"><i class=\"icon-book\"></i> Charm </a>\n      <button class=\"btn\"><i class=\"icon-ban-circle\"></i> Exposed </button>\n      <a href=\"relations\" class=\"btn\"><i class=\"icon-random\"></i> Relations </a>\n    </div>\n  </div>\n    <div class=\"span4\">\n      <div class=\"well\">\n        <span>\n          <b>Charm:</b>\n          <a href=\"/charms/charms/";
+  stack1 = depth0.charm;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "/json\">";
+  stack1 = depth0.charm;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "</a></span>\n        <br/>\n        <span> <b>Units:</b></span>\n        <br/>\n        <span> <b>Relations:</b></span>\n        <br/>\n        <span><b>Exposed:</b> ";
+  stack1 = depth0.service;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.exposed;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + "</span>\n        <br/>\n      </div>\n    </div>\n</div>\n\n<div class=\"row\">\n    <div class=\"span12\">\n    <form class=\"form-horizontal\">\n      <legend>";
+  stack1 = depth0.service;
+  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
+  stack1 = typeof stack1 === functionType ? stack1() : stack1;
+  buffer += escapeExpression(stack1) + " settings</legend>\n\n       ";
+  foundHelper = helpers.settings;
+  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
+  else { stack1 = depth0.settings; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
+  if (!helpers.settings) { stack1 = blockHelperMissing.call(depth0, stack1, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
+  if(stack1 || stack1 === 0) { buffer += stack1; }
+  buffer += "\n\n        <div class=\"control-group\">\n          <div class=\"controls\">\n            <button type=\"submit\" cls=\"btn\">Update</button>\n          </div>\n        </div>\n      </form> \n</div>";
+  return buffer;});
+  
     Templates['service-constraints'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
   helpers = helpers || Handlebars.helpers;
   var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
@@ -207,77 +383,6 @@
   buffer += "\n	  </ul>\n	</div>\n      </div>\n";
   return buffer;});
   
-    Templates['service-config'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
-  helpers = helpers || Handlebars.helpers;
-  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
-
-function program1(depth0,data) {
-  
-  var buffer = "", stack1, foundHelper;
-  buffer += "\n\n        <div class=\"control-group\">\n          <div class=\"well\">\n            ";
-  foundHelper = helpers.description;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.description; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "\n          </div>\n          <div class=\"control-label\" for=\"";
-  foundHelper = helpers.name;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "\">";
-  foundHelper = helpers.type;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.type; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + ": ";
-  foundHelper = helpers.name;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "</div>\n          <div class=\"controls\">\n             <input type=\"text\" id=\"input-";
-  foundHelper = helpers.name;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "\" value=\"";
-  foundHelper = helpers.value;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.value; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "\"/>\n          </div>          \n        </div>\n \n      ";
-  return buffer;}
-
-  buffer += "<div class=\"row\">\n  <div class=\"span8\">\n    <h1><a href=\"/service/";
-  stack1 = depth0.service;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "/\"> Service ";
-  stack1 = depth0.service;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "</a></h1>\n    <br/> <br/>\n    <div class=\"btn-group\">\n      <a href=\".\" class=\"btn\"><i class=\"icon-th\"></i> Units </a>\n      <a href=\"config\" class=\"btn\"><i class=\"icon-cog\"></i> Settings </a>\n      <a href=\"constraints\" class=\"btn\"><i class=\"icon-leaf\"></i> Constraints</a>\n      <a href=\"/charms/charms/";
-  stack1 = depth0.charm;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "/json\"\n         class=\"btn\"><i class=\"icon-book\"></i> Charm </a>\n      <button class=\"btn\"><i class=\"icon-ban-circle\"></i> Exposed </button>\n      <a href=\"relations\" class=\"btn\"><i class=\"icon-random\"></i> Relations </a>\n    </div>\n  </div>\n    <div class=\"span4\">\n      <div class=\"well\">\n        <span>\n          <b>Charm:</b>\n          <a href=\"/charms/charms/";
-  stack1 = depth0.charm;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "/json\">";
-  stack1 = depth0.charm;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "</a></span>\n        <br/>\n        <span> <b>Units:</b></span>\n        <br/>\n        <span> <b>Relations:</b></span>\n        <br/>\n        <span><b>Exposed:</b> ";
-  stack1 = depth0.service;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.exposed;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "</span>\n        <br/>\n      </div>\n    </div>\n</div>\n\n<div class=\"row\">\n    <div class=\"span12\">\n    <form class=\"form-horizontal\">\n      <legend>";
-  stack1 = depth0.service;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + " settings</legend>\n\n       ";
-  foundHelper = helpers.settings;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
-  else { stack1 = depth0.settings; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  if (!helpers.settings) { stack1 = blockHelperMissing.call(depth0, stack1, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
-  if(stack1 || stack1 === 0) { buffer += stack1; }
-  buffer += "\n\n        <div class=\"control-group\">\n          <div class=\"controls\">\n            <button type=\"submit\" cls=\"btn\">Update</button>\n          </div>\n        </div>\n      </form> \n</div>";
-  return buffer;});
-  
     Templates['service-relations'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
   helpers = helpers || Handlebars.helpers;
   var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
@@ -341,111 +446,6 @@
   buffer += "\n       </tbody>\n      </table>\n    </div>\n</div>";
   return buffer;});
   
-    Templates['charm-collection'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
-  helpers = helpers || Handlebars.helpers;
-  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
-
-function program1(depth0,data) {
-  
-  var buffer = "", stack1, foundHelper;
-  buffer += "\n              <li class=\"span3\">\n		<div class=\"thumbnail\" data-charm-url=\"";
-  foundHelper = helpers.data_url;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.data_url; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "\">\n		  <h5>~";
-  foundHelper = helpers.owner;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.owner; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "/";
-  foundHelper = helpers.series;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.series; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "/";
-  foundHelper = helpers.name;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.name; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + " <i class=\"icon-user\"></i></h5>\n		  <span>";
-  foundHelper = helpers.summary;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.summary; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "</span>\n		</div>\n	      </li>\n              ";
-  return buffer;}
-
-  buffer += "      <div>\n        <h1>Charm Collection</h1>\n	<form class=\"well form-inline\">\n	  <label>Series <input type=\"text\" class=\"input-small\" placeholder=\"Precise\"></label>\n	  <label>Owner <input type=\"text\" class=\"input-small\" placeholder=\"Ubuntu\"></label>\n	  <label>Provides <input type=\"text\" class=\"input-small\" placeholder=\"Owner\"></label>\n	  <label>Requires <input type=\"text\" class=\"input-small\" placeholder=\"Owner\"></label>\n	  <label>\n	    Sort \n	    <select class=\"input-small\">\n	      <option>Match</option>\n	      <option>Modified</option>\n	      <option>Owner</option>\n	      <option>Series</option>\n	    </select>\n	  </label>\n	  <button type=\"submit\" class=\"btn\">Search</button>\n	</form>\n	<div class=\"collection\">\n	  <div class=\"charm\">\n	    <ul class=\"thumbnails\">\n              ";
-  foundHelper = helpers.charms;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
-  else { stack1 = depth0.charms; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  if (!helpers.charms) { stack1 = blockHelperMissing.call(depth0, stack1, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
-  if(stack1 || stack1 === 0) { buffer += stack1; }
-  buffer += "\n	    </ul>\n	  </div>\n	</div>\n      </div>\n";
-  return buffer;});
-  
-    Templates['service'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
-  helpers = helpers || Handlebars.helpers;
-  var buffer = "", stack1, foundHelper, functionType="function", escapeExpression=this.escapeExpression, self=this, blockHelperMissing=helpers.blockHelperMissing;
-
-function program1(depth0,data) {
-  
-  var buffer = "", stack1, foundHelper;
-  buffer += "\n	    <li class=\"span3\">\n	      <div class=\"thumbnail well\" id=\"";
-  foundHelper = helpers.id;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.id; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "\">\n		<h5>";
-  foundHelper = helpers.id;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.id; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "</h5>\n		<span>";
-  foundHelper = helpers.agent_state;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.agent_state; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "</span> <br/>\n		<span>";
-  foundHelper = helpers.public_address;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{}}); }
-  else { stack1 = depth0.public_address; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  buffer += escapeExpression(stack1) + "</span>\n	      </div>\n	    </li>\n	    ";
-  return buffer;}
-
-  buffer += " <div class=\"row\">\n	<div class=\"span8\">\n	  <h1><a href=\"/service/";
-  stack1 = depth0.service;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "/\"> Service ";
-  stack1 = depth0.service;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "</a></h1>\n	  <br/> <br/>\n    <div class=\"btn-group\">\n      <a href=\".\" class=\"btn\"><i class=\"icon-th\"></i> Units </a>\n      <a href=\"config\" class=\"btn\"><i class=\"icon-cog\"></i> Settings </a>\n      <a href=\"constraints\" class=\"btn\"><i class=\"icon-leaf\"></i> Constraints</a>\n      <a href=\"/charms/charms/";
-  stack1 = depth0.charm;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "/json\"\n         class=\"btn\"><i class=\"icon-book\"></i> Charm </a>\n      <button class=\"btn\"><i class=\"icon-ban-circle\"></i> Exposed </button>\n      <a href=\"relations\" class=\"btn\"><i class=\"icon-random\"></i> Relations </a>\n    </div>\n	</div>\n	<div class=\"span4\">\n	  <div class=\"well\">\n	    <span>\n	      <b>Charm:</b>\n	      <a href=\"/charms/charms/";
-  stack1 = depth0.charm;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.name;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "/json\">";
-  stack1 = depth0.charm;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.id;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "</a></span>\n	    <br/>\n	    <span> <b>Units:</b></span>\n	    <br/>\n	    <span> <b>Relations:</b></span>\n	    <br/>\n	    <span><b>Exposed:</b> ";
-  stack1 = depth0.service;
-  stack1 = stack1 == null || stack1 === false ? stack1 : stack1.exposed;
-  stack1 = typeof stack1 === functionType ? stack1() : stack1;
-  buffer += escapeExpression(stack1) + "</span>\n	    <br/>\n	  </div>\n	</div>\n </div>\n\n <div class=\"row\">\n	<div class=\"span12\">\n	  <ul class=\"nav nav-tabs\">\n	    <li class=\"active\"><a href=\".\">All</a></li>\n	    <li><a href=\"?state=running\">Running</a></li>\n	    <li><a href=\"?state=pending\">Pending</a></li>\n	    <li><a href=\"?state=error\">Error</a></li>\n	  </ul>\n	</div>\n </div>\n\n\n <div class=\"collection\">\n	<div class=\"charm\">\n	  <ul class=\"thumbnails\">\n	    ";
-  foundHelper = helpers.units;
-  if (foundHelper) { stack1 = foundHelper.call(depth0, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
-  else { stack1 = depth0.units; stack1 = typeof stack1 === functionType ? stack1() : stack1; }
-  if (!helpers.units) { stack1 = blockHelperMissing.call(depth0, stack1, {hash:{},inverse:self.noop,fn:self.program(1, program1, data)}); }
-  if(stack1 || stack1 === 0) { buffer += stack1; }
-  buffer += "	    \n	  </ul>\n	</div>\n </div>\n\n";
-  return buffer;});
-  
-    Templates['overview'] = Y.Handlebars.template(function (Handlebars,depth0,helpers,partials,data) {
-  helpers = helpers || Handlebars.helpers;
-  
-
-
-  return "<div id=\"canvas\"></div>\n";});
-  
 
   
 

=== modified file 'app/views/charm.js'
--- app/views/charm.js	2012-09-07 15:58:58 +0000
+++ app/views/charm.js	2012-09-10 08:45:43 +0000
@@ -1,3 +1,5 @@
+"use strict";
+
 YUI.add("juju-view-charm-collection", function(Y) {
 
 var views = Y.namespace("juju.views"),
@@ -35,13 +37,13 @@
 });
 
 Y.Handlebars.registerHelper('markdown', function(text) {
-    if (!text || text == undefined) {return '';}
+    if (!text || text === undefined) {return '';}
     return new Y.Handlebars.SafeString(
         Y.Markdown.toHTML(text));
 });
 
 
-CharmView = Y.Base.create('CharmView', Y.View, [], {
+var CharmView = Y.Base.create('CharmView', Y.View, [], {
     initializer: function () {
         this.set('charm', null);
         console.log("Loading charm view", this.get('charm_data_url'));
@@ -76,7 +78,7 @@
     },
 
     on_charm_data: function (io_request) {
-        charm = Y.JSON.parse(
+        var charm = Y.JSON.parse(
             io_request.response.results[0].responseText);
         console.log('results update', charm, this);
         this.set('charm', charm);
@@ -89,7 +91,7 @@
     }
 });
 
-CharmCollectionView = Y.Base.create('CharmCollectionView', Y.View, [], {
+var CharmCollectionView = Y.Base.create('CharmCollectionView', Y.View, [], {
 
     initializer: function () {
         console.log("View: Initialized: Charm Collection", this.get('query'));
@@ -167,4 +169,3 @@
         'gallery-markdown',
         'view']
 });
-

=== modified file 'app/views/environment.js'
--- app/views/environment.js	2012-08-29 03:22:26 +0000
+++ app/views/environment.js	2012-09-07 20:29:04 +0000
@@ -1,9 +1,11 @@
+"use strict";
+
 YUI.add("juju-view-environment", function(Y) {
 
 var views = Y.namespace("juju.views"),
     Templates = views.Templates;
 
-EnvironmentView = Y.Base.create('EnvironmentView', Y.View, [views.JujuBaseView], {
+var EnvironmentView = Y.Base.create('EnvironmentView', Y.View, [views.JujuBaseView], {
     events: {},
 
     initializer: function () {
@@ -31,11 +33,18 @@
         var services = m.services.toArray();
         var relations = m.relations.toArray();
 
+        // Scales for unit sizes
+        // XXX magic numbers will have to change; likely during
+        // the pan/zoom work
+        var service_scale_width = d3.scale.log().range([164, 200]);
+        var service_scale_height = d3.scale.log().range([64, 100]);
+
         var tree = d3.layout.force()
             .on("tick", tick)
             .charge(-450)
+            .gravity(0.05)
             .distance(200)
-            .friction(0)
+            .friction(0.5)
             .size([width, height]);
 
         var vis = d3.select(container.getDOMNode())
@@ -51,7 +60,7 @@
                 .attr("y1", function(d) { return d.source.y; })
                 .attr("x2", function(d) { return d.target.x; })
                 .attr("y2", function(d) { return d.target.y; });
-            
+
             node.attr("transform", function(d) {
                           return "translate(" + d.x + "," + d.y + ")"; });
         }
@@ -64,7 +73,7 @@
             });
             return rel_services;
         }
-        
+
         function processRelations(rels) {
             var pairs = [];
             Y.each(rels, function(rel) {
@@ -72,7 +81,7 @@
                 // skip peer for now
                 if (pair.length == 2) {
                     pairs.push({source: pair[0],
-                               target: pair[1]});                    
+                               target: pair[1]});
                 }
 
             });
@@ -84,7 +93,7 @@
             .links(rel_data);
 
         var link = vis.selectAll("path.relation")
-            .data(rel_data, 
+            .data(rel_data,
                   function(d) {return d;});
 
         link.enter().insert("svg:line", "g.service")
@@ -105,34 +114,66 @@
 
 
         node.append("rect")
-        .attr("class", function(d) {
-                  return self.stateToStyle(
-                        d.get('agent_state'), 'service-border');})
-        .attr("width", 164)
-        .attr("height", 64);
+        .attr("class", "service-border")
+        .attr("width", function(d) {
+            return service_scale_width(d.get('unit_count')); })
+        .attr("height", function(d) {
+            return service_scale_height(d.get('unit_count')); });
 
         var service_labels = node.append("text").append("tspan")
             .attr("class", "name")
-            .attr("x", 4)
+            .attr("x", 54)
             .attr("y", "1em")
             .text(function(d) {return d.get("id"); });
 
         var charm_labels = node.append("text").append("tspan")
-            .attr("x", 4)
+            .attr("x", 54)
             .attr("y", "2.5em")
             .attr("dy", "3em")
             .attr("class", "charm-label")
             .text(function(d) {
                       return d.get("charm"); });
 
-        var unit_count = node.append("text")
-        .attr("class", "unit-count")
-        .attr("dx", "4em")
-        .attr("dy", "1em")
-        .text(function(d) {
-                  var units = m.units.get_units_for_service(d);
-                  return self.humanizeNumber(units.length);
-              });
+        var status_chart_arc = d3.svg.arc()
+            .innerRadius(10)
+            .outerRadius(25);
+        var status_chart_layout = d3.layout.pie()
+            .value(function(d) { return (d.value ? d.value : 1); });
+
+        var status_chart = node.append("g")
+            .attr("class", "service-status")
+            .attr("transform", "translate(30,32)");
+        var status_arcs = status_chart.selectAll("path")
+            .data(function(d) {
+                var aggregate_map = d.get('aggregated_status'),
+                    aggregate_list = [];
+
+                for (var idx in aggregate_map) {
+                    aggregate_list.push({name: idx, value: aggregate_map[idx]});
+                }
+
+                return status_chart_layout(aggregate_list);
+            })
+            .enter().append("path")
+            .attr("d", status_chart_arc)
+            .attr("class", function(d) { return "status-" + d.data.name; })
+            .attr("fill-rule", "evenodd")
+            .append("title").text(function(d) {
+                return d.data.name;
+            });
+
+        // Add the unit counts, visible only on hover
+        var unit_count = status_chart.append("text")
+            .attr("class", "unit-count hide-count")
+            .on("mouseover", function() {
+                d3.select(this).attr("class", "unit-count show-count");
+            })
+            .on("mouseout", function() {
+                d3.select(this).attr("class", "unit-count hide-count");
+            })
+            .text(function(d) {
+                return self.humanizeNumber(d.get('unit_count'));
+            });
 
         tree.start();
     }

=== modified file 'app/views/search.js'
--- app/views/search.js	2012-09-07 15:58:58 +0000
+++ app/views/search.js	2012-09-10 08:45:43 +0000
@@ -1,52 +1,54 @@
+"use strict";
+
 YUI.add("juju-view-charmsearch", function(Y) {
 
 var views = Y.namespace("juju.views");
 
-NavigationBarView = Y.Base.create('NavigationBarView', Y.View, [], {
+var NavigationBarView = Y.Base.create('NavigationBarView', Y.View, [], {
 
     initializer: function () {
-	Y.log("View: Initialized: Charm Search");
-	// This view is always attached / else remove this when no longer valid.
-	// The App framework only sets the activeView up as a target (v3.6.0)
-	this.addTarget(this.get('app'));
-	this.publish('showCharmCollection', {preventable: false, broadcast: true});
+        Y.log("View: Initialized: Charm Search");
+        // This view is always attached / else remove this when no longer valid.
+        // The App framework only sets the activeView up as a target (v3.6.0)
+        this.addTarget(this.get('app'));
+        this.publish('showCharmCollection', {preventable: false, broadcast: true});
     },
 
     render: function () {
-	/* Navigation bar search defaults to show detailed charm collection results.
+        /* Navigation bar search defaults to show detailed charm collection results.
         var app = Y.namespace("juju").AppInstance;
-	Y.one('#charm-search').plug(Y.Plugin.AutoComplete, {
-	    resultHighlighter: 'phraseMatch',
-	    minQueryLength: 3,
-	    resultListLocator: 'results',
-	    resultTextLocator: function (result) {
-		if (result.owner == 'charmers') {
-		    return result.series + "/" + result.name;
-		}
-		return result.owner + "/" + result.series + "/" + result.name;
-	    },
-	    source: app.get('charm_search_url') + 'search/json?search_text={query}'
-	});
-	*/
+        Y.one('#charm-search').plug(Y.Plugin.AutoComplete, {
+            resultHighlighter: 'phraseMatch',
+            minQueryLength: 3,
+            resultListLocator: 'results',
+            resultTextLocator: function (result) {
+                if (result.owner == 'charmers') {
+                    return result.series + "/" + result.name;
+                }
+                return result.owner + "/" + result.series + "/" + result.name;
+            },
+            source: app.get('charm_search_url') + 'search/json?search_text={query}'
+        });
+        */
 
-	Y.one('#omnibar').on('submit', Y.bind(this.show_charm_store, this));
+        Y.one('#omnibar').on('submit', Y.bind(this.show_charm_store, this));
         return this;
     },
 
     show_charm_store: function(evt) {
-
-	console.log("clicked search");
+        console.log("clicked search");
         var app = this.get('app');
-	evt.preventDefault();
-	evt.stopImmediatePropagation();
-
-	// if we're already on the page dont render.
-	if (app.get('activeView') == 'CharmCollectionView')
-	    return
-
-	charm_url = Y.one('#charm-search').get('value');
-	console.log('Fire show charm collection', this, charm_url);
-	this.fire('showCharmCollection', {query: charm_url});
+
+        evt.preventDefault();
+        evt.stopImmediatePropagation();
+
+        // if we're already on the page dont render.
+        if (app.get('activeView') == 'CharmCollectionView')
+            return;
+
+        var charm_url = Y.one('#charm-search').get('value');
+        console.log('Fire show charm collection', this, charm_url);
+        this.fire('showCharmCollection', {query: charm_url});
     }
 
 });

=== modified file 'app/views/service.js'
--- app/views/service.js	2012-09-01 01:45:08 +0000
+++ app/views/service.js	2012-09-07 14:59:56 +0000
@@ -1,9 +1,11 @@
+"use strict";
+
 YUI.add("juju-view-service", function(Y) {
 
 var views = Y.namespace("juju.views"),
     Templates = views.Templates;
 
-BaseServiceView = Y.Base.create("BaseServiceView", Y.View, [views.JujuBaseView], {
+var BaseServiceView = Y.Base.create("BaseServiceView", Y.View, [views.JujuBaseView], {
 
     initializer: function() {
         console.log("View: initialized:", this.name);
@@ -11,9 +13,9 @@
     }
 
 });
-            
-
-ServiceRelations = Y.Base.create('ServiceRelationsView', Y.View, [views.JujuBaseView], {
+
+
+var ServiceRelations = Y.Base.create('ServiceRelationsView', Y.View, [views.JujuBaseView], {
 
     template: Templates["service-relations"],
 
@@ -33,7 +35,7 @@
 views.service_relations = ServiceRelations;
 
 
-ServiceConstraints = Y.Base.create("ServiceConstraintsView", Y.View, [views.JujuBaseView], {
+var ServiceConstraints = Y.Base.create("ServiceConstraintsView", Y.View, [views.JujuBaseView], {
 
     template: Templates["service-constraints"],
 
@@ -41,7 +43,7 @@
         var container = this.get('container'),
                  self = this,
                     m = this.get('domain_models');
-        service = this.get('model');
+        var service = this.get('model');
         var constraints = service.get('constraints');
         var display_constraints = [];
 
@@ -69,7 +71,7 @@
 
 views.service_constraints = ServiceConstraints;
 
-ServiceConfigView = Y.Base.create('ServiceConfigView', Y.View, [views.JujuBaseView], {
+var ServiceConfigView = Y.Base.create('ServiceConfigView', Y.View, [views.JujuBaseView], {
 
     template: Templates["service-config"],
 
@@ -92,7 +94,7 @@
         var config = service.get('config');
         var schema = charm.get('config');
 
-        settings = [];
+        var settings = [];
         var field_def;
 
         for (var field_name in config) {
@@ -113,7 +115,7 @@
 
 views.service_config = ServiceConfigView;
 
-ServiceView = Y.Base.create('ServiceView', Y.View, [views.JujuBaseView], {
+var ServiceView = Y.Base.create('ServiceView', Y.View, [views.JujuBaseView], {
 
     template: Templates.service,
 

=== removed file 'app/views/status.js'
--- app/views/status.js	2012-08-03 23:14:37 +0000
+++ app/views/status.js	1970-01-01 00:00:00 +0000
@@ -1,41 +0,0 @@
-// This is a temp view to get the router working
-// remove later, testing basic routing in App
-
-YUI.add("juju-status", function(Y) {
-
-var     views = Y.namespace("juju.views");
-            
-
-StatusView = Y.Base.create('StatusView', Y.View, [], {
-
-    initializer: function () {
-        var template_src = Y.one("#t-status").getHTML();
-        this.template = Y.Handlebars.compile(template_src); 
-    },
-
-    render: function () {
-        var container = this.get('container'),
-            m = this.get('domain_models'),
-            charmData;
-
-        charmData = m.charms.map(function (charm) {
-            var data = charm.toJSON();
-            console.log(charm, data);
-            // Add `clientId` to the data, this is ignored by `toJSON()`. This
-            // will be used by the template and is an easy way to regain access
-            // to the associated Repo model.
-            data.clientId = charm.get('clientId');
-            return data;
-        });
-
-        container.setHTML(this.template({
-            charms: charmData
-        }));
-        return this;
-    }
-});
-
-views.status = StatusView;
-}, "0.1.0", {
-    requires: ['base-build', 'handlebars', 'node', "view", "json-stringify"]
-});

=== modified file 'app/views/unit.js'
--- app/views/unit.js	2012-08-23 19:49:40 +0000
+++ app/views/unit.js	2012-09-07 14:59:56 +0000
@@ -1,8 +1,10 @@
+"use strict";
+
 YUI.add("juju-view-unit", function(Y) {
 
 var views = Y.namespace("juju.views");
 
-UnitView = Y.Base.create('UnitView', Y.View, [], {
+var UnitView = Y.Base.create('UnitView', Y.View, [], {
     initializer: function () {
       console.log("view.init.unit", this.get('unit'));
     },
@@ -28,6 +30,6 @@
                'base',
                'handlebars',
                'node',
-               "view"]
+               'view']
 
 });

=== modified file 'app/views/utils.js'
--- app/views/utils.js	2012-09-01 01:45:08 +0000
+++ app/views/utils.js	2012-09-07 15:14:54 +0000
@@ -1,18 +1,22 @@
+"use strict";
+
 YUI.add("juju-view-utils", function(Y) {
 
 var views = Y.namespace("juju.views");
 
-JujuBaseView = Y.Base.create('JujuBaseView', Y.Base, [], {
+var JujuBaseView = Y.Base.create('JujuBaseView', Y.Base, [], {
 
     bindModelView: function(model) {
         model = model || this.get('model');
         // If this view has a model, bubble model events to the view.
-        model && model.addTarget(this);
+        if (model) {
+            model.addTarget(this);
+        }
 
         // If the model gets swapped out, reset targets accordingly.
         this.after('modelChange', function (ev) {
-            ev.prevVal && ev.prevVal.removeTarget(this);
-            ev.newVal && ev.newVal.addTarget(this);
+            if (ev.prevVal) ev.prevVal.removeTarget(this);
+            if (ev.newVal) ev.newVal.addTarget(this);
         });
 
         // Re-render this view when the model changes.
@@ -51,7 +55,7 @@
     },
 
     humanizeNumber: function(n) {
-        var units = [ [1000, 'K'], 
+        var units = [ [1000, 'K'],
                       [1000000, 'M'],
                       [1000000000, 'B']],
             result = n;
@@ -61,7 +65,7 @@
                     unit = sizer[1];
                    if(n > threshold) {
                     result = (n / threshold);
-                    if (n % threshold != 0) {
+                    if (n % threshold !== 0) {
                         result = result.toFixed(1);
                     }
                     result = result + unit;

=== modified file 'config.js'
--- config.js	2012-09-07 09:02:42 +0000
+++ config.js	2012-09-10 08:45:43 +0000
@@ -1,15 +1,11 @@
-var config = { 
-"application": {
-    "socket_url": process.env.JUJU_WS || "ws://localhost:8081/ws"
-    },
-
-"server": {
-      "port": 8888,
-      "public_hostname": "localhost",
-      "template_dir": __dirname + "/app/templates/",
-      "view_dir": __dirname + "/lib/views/",
-      "public_dir": __dirname + "/app"
-  }
+var config = {
+    "server": {
+        "port": 8888,
+        "public_hostname": "localhost",
+        "template_dir": __dirname + "/app/templates/",
+        "view_dir": __dirname + "/lib/views/",
+        "public_dir": __dirname + "/app"
+    }
 };
 
 exports.config = config;

=== modified file 'jshint.config'
--- jshint.config	2012-08-03 11:34:20 +0000
+++ jshint.config	2012-09-09 19:46:35 +0000
@@ -1,5 +1,14 @@
 {
   "node": true,
-  "YUI": true
+  "predef":
+  [
+    "YUI",
+    "d3",
+    "after",
+    "before",
+    "describe",
+    "it",
+    "GlobalConfig"
+  ]
 
 }

=== removed file 'lib/base.js'
--- lib/base.js	2012-08-22 16:17:07 +0000
+++ lib/base.js	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-var path = require("path"),
-    fs = require("fs"),
-    config = require("../app/modules.js").GlobalConfig;
-
-port = process.env.PORT || 8888;
-BASE_URL = "http://localhost:" + port;
-
-// browser = new Browser();
-// window = browser.window;
-// location = browser.location;
-// document = browser.document;
-// navigator = window.navigator;
-// CSSStyleDeclaration = window.CSSStyleDeclaration;
-// require("sizzle");
-// Sizzle = window.Sizzle;
-// process.env.TZ = "America/Los_Angeles";
-
-// // Bind browser elements to config for YUI to work
-// config.win = window;
-// config.doc = document;
-
-
-config.combine = false;
-config.debug = false;
-config.filter = "info";
-config.useSync = false;
-
-function fixPath(obj, name) {
-    var el = obj[name],
-        fp = el.fullpath;
-    if (fp) {
-        if (fp.indexOf("/") === 0) {
-            fp = el.fullpath.slice(1);
-        }
-        el.fullpath = path.resolve('app', fp);
-    }
-}
-
-for (var name in config.groups.juju.modules) {
-    fixPath(config.groups.juju.modules, name);
-}
-
-for (var name in config.groups.d3.modules) {
-    fixPath(config.groups.d3.modules, name);
-}
-
-exports.TestConfig = config;
-
-exports.AppConfig = {
-    serverRouting: false,
-    html5: false,
-    container: "#main",
-    viewContainer: "#main"
-};

=== modified file 'lib/server.js'
--- lib/server.js	2012-08-24 20:08:54 +0000
+++ lib/server.js	2012-09-07 15:14:54 +0000
@@ -1,9 +1,11 @@
+"use strict";
+
 var express = require("express"),
     server = express(),
     fs = require("fs"),
     path = require("path"),
     config = require("../config").config.server,
-    public_dir = config["public_dir"],
+    public_dir = config.public_dir,
     Templates = require("./templates.js"),
     view = require("./view.js");
 
@@ -15,7 +17,9 @@
     server.engine("handlebars", view.handlebars);
 
     server.use(express.logger("dev"));
-    server.use(express.static(public_dir));
+    // 'static' is a reserved word so dot notation is not used to
+    // avoid annoying the linter.
+    server.use(express['static'](public_dir));
 });
 
 
@@ -27,7 +31,7 @@
 Templates.watchTemplates(function() {
     console.log("Regenerated Templates");
 });
-            
+
 Templates.watchViews(function() {
     console.log("Regenerating Views");
 });
@@ -37,8 +41,8 @@
 
 server.get('/stats/', function(req, res) {
     res.json({
-	uptime: process.uptime(),
-	memory: process.memoryUsage()
+        uptime: process.uptime(),
+        memory: process.memoryUsage()
     });
 });
 
@@ -46,4 +50,4 @@
     res.sendfile("app/index.html");
 });
 
-exports.server = server;
\ No newline at end of file
+exports.server = server;

=== modified file 'lib/templates.js'
--- lib/templates.js	2012-09-01 01:45:08 +0000
+++ lib/templates.js	2012-09-07 20:45:25 +0000
@@ -1,3 +1,5 @@
+"use strict";
+
 var fs   = require('fs'),
     path = require('path'),
     YUI = require("yui").YUI,
@@ -7,7 +9,7 @@
     cache        = {};
 
 var Y = YUI({useSync: true}).use(["handlebars", "oop"]);
-    
+
 function getRaw() {
     if (cache.raw) {
         return Y.merge(cache.raw);
@@ -96,7 +98,7 @@
                     template: template
             });
         });
-    
+
     return {
         templates: templates,
         partials: partials
@@ -105,13 +107,6 @@
 
 
 var templateSpecs = {
-    index: { 
-        output: __dirname + "/../app/index.html",
-        callback: function(strategy, name) {
-            renderTemplate(name, config.application, strategy.output);
-        }
-    },
-
     templates: {
         output: __dirname + "/../app/templates.js",
         callback: function(strategy, name) {
@@ -120,7 +115,7 @@
             renderTemplate(name, prepareTemplate(), strategy.output);
         }
     },
-        
+
     manifest: {
          output: __dirname + "/../manifest.json",
          callback: function(strategy, name) {
@@ -131,7 +126,7 @@
     stylesheet: {
         output: __dirname + "/../app/assets/stylesheets/juju-gui.css",
         callback: function(strategy, name) {
-                parser = new less.Parser({
+            var parser = new less.Parser({
                     paths:[config.server.view_dir],
                     filename: 'stylesheet.less'
             }),
@@ -141,10 +136,10 @@
                 if (e) {
                     console.log("LESS Generation Error", e);
                 }
-                fs.writeFileSync(strategy.output, 
+                fs.writeFileSync(strategy.output,
                    tree.toCSS({compress: true}));
             });
-                                             
+
         }
     }
 };
@@ -154,7 +149,7 @@
     fs.watch(config.server.template_dir, function(event, filename) {
         //on dir change regen the cache
         if (filename.slice(0, 1) === ".") {return;}
-        strategy = templateSpecs["templates"];
+        var strategy = templateSpecs.templates;
         strategy.callback(strategy, "templates");
         if (cb) {cb();}
     });
@@ -168,7 +163,7 @@
         if (filename.slice(0, 1) === ".") {return;}
         var basename = filename.replace(".handlebars", ''),
             strategy = templateSpecs[basename];
-                 
+
         strategy.callback(strategy, basename);
         if (cb) {cb();}
     });
@@ -176,7 +171,7 @@
 exports.watchViews = watchViews;
 
 function renderTemplate(view_name, data, output_filename) {
-     view.handlebars(__dirname + "/views/" + view_name + ".handlebars", 
+     view.handlebars(__dirname + "/views/" + view_name + ".handlebars",
          data,
         function(err, str) {
         if (err) {
@@ -185,7 +180,7 @@
         }
 
         if (output_filename) {
-            fs.writeFileSync(output_filename, str);                
+            fs.writeFileSync(output_filename, str);
         }
     });
 }

=== modified file 'lib/view.js'
--- lib/view.js	2012-08-24 20:08:54 +0000
+++ lib/view.js	2012-09-07 14:35:08 +0000
@@ -1,3 +1,5 @@
+"use strict";
+
 var Handlebars = require('yui/handlebars').Handlebars,
     fs = require("fs"),
     cache = {};
@@ -30,4 +32,3 @@
     fn(null, tmpl(options));
   });
 };
-

=== removed file 'lib/views/index.handlebars'
--- lib/views/index.handlebars	2012-09-07 15:58:58 +0000
+++ lib/views/index.handlebars	1970-01-01 00:00:00 +0000
@@ -1,63 +0,0 @@
-<!DOCTYPE html>
-<html>
-  <head>
-    <meta charset="utf-8">
-    <!-- GENERATED FROM lib/views/index.handlebars -->
-    <title>Juju Admin</title>
-    <meta name="viewport" content="width=device-width,initial-scale=1.0">
-    <meta name="description" content="">
-    <meta name="author" content="Juju team">
-    <link rel="stylesheet" href="/assets/stylesheets/bootstrap-2.0.4.css">
-    <link rel="stylesheet"
-          href="/assets/stylesheets/bootstrap-responsive-2.0.4.css">
-    <link rel="stylesheet" href="/assets/stylesheets/juju-gui.css">
-    <!--[if lt IE 9]>
-    <script src="http://html5shim.googlecode.com/svn/trunk/html5.js"></script>
-    <![endif]-->
-
-  </head>
-
-  <body>
-
-    <div class="navbar navbar-fixed-top">
-      <div class="navbar-inner">
-
-        <div class="container">
-
-              <a class="brand" href="/">
-	        <img height="32" alt="Juju GUI" src="/assets/images/juju-white.png">
-              </a>
-
-	      <form id="omnibar" class="navbar-search pull-right yui3-skin-sam" method="GET">
-		<input id="charm-search" name="query" type="text" class="search-query span3"
-		       placeholder="Search"/>
-		<!-- <input id="omnibar-submit" class="btn" type="submit" value="search"/> -->
-	      </form>
-
-        </div>
-      </div>
-    </div>
-
-    <div id="main" class="container">
-    </div> <!-- /container -->
-
-    <!-- javascript away -->
-    <script src="/assets/javascripts/yui/yui/yui-debug.js"></script>
-    <script src="/modules.js"></script>
-    <script>
-      YUI(GlobalConfig).use("juju-gui", function(Y) {
-      app = new Y.juju.App({
-              serverRouting: false,
-              html5: true,
-              socket_url: '{{{socket_url}}}',
-              contain : "#main",
-              viewContainer: "#main",
-              // FIXME: turn off transitions until they are fixed.
-              transitions: false,
-              charm_store: new Y.DataSource.IO({
-                  source: 'http://jujucharms.com/'})
-          });
-      });
-    </script>
-  </body>
-</html>

=== modified file 'lib/views/manifest.handlebars'
--- lib/views/manifest.handlebars	2012-09-01 01:45:08 +0000
+++ lib/views/manifest.handlebars	2012-09-07 04:54:24 +0000
@@ -18,7 +18,6 @@
   },
   "permissions": [
     "unlimitedStorage",
-    "notifications",
-    "{{{application.charm_store_url}}}*"
+    "notifications"
   ]
 }

=== modified file 'lib/views/stylesheet.less'
--- lib/views/stylesheet.less	2012-09-01 01:45:08 +0000
+++ lib/views/stylesheet.less	2012-09-07 15:38:58 +0000
@@ -8,19 +8,50 @@
 .state-started { stroke: #000000;}
 .state-pending { stroke: #6597E8;}
 
-g.service .charm-label { font-size: 0.7em;
-                         fill: #333333;}
-g.service .name { font-weight: bold;
-                  font-family: "Ubuntu";
-                  font-size: 1.6em; fill: #333333;}
-g.service .service-border {stroke-width: 2px;}
-g.service .unit-count {
-    stroke: #000000; stroke-width: 1px;
-    font-family: "Ubuntu";
-    fill: #333333; font-size: 2.5em;}
-g.service { fill: #f5f5f5; stroke: black;}
-
-g.unit .address {fill: #ffffff; font-size: 0.8em;}
-g.unit .unit-border { stroke-width: 2px; fill: #a0a0a0;}
-g.unit { stroke-width: 0; font-weight: bold;
-         font-family: "Ubuntu"; font-size: 1.2em; fill: #1626cf;}
+g.service {
+    fill: #f5f5f5; stroke: black;
+
+    .charm-label { font-size: 0.7em;
+        fill: #333333;}
+    .name { font-weight: bold;
+        font-family: "Ubuntu";
+        font-size: 1.6em; fill: #333333;}
+    .service-border {stroke-width: 2px;}
+    .unit-count {
+        stroke-width: 0;
+        text-anchor: middle;
+        dominant-baseline: central;
+        fill: rgba(0,0,0,0);
+        font-family: "Ubuntu";
+        font-size: 2.5em;
+
+        &.show-count {
+            fill: rgba(0,0,0,1);}
+        &.hide-count {
+            fill: rgba(0,0,0,0);}
+    }
+}
+g.service-status {
+    path {
+        stroke-width: 0;
+
+        &.status-pending {
+            fill: #fcd305;}
+        &.status-started {
+            fill: #b7b7b7;}
+        &.status-installed {
+            fill: #ffffff;}
+        &.status-error {
+            fill: #c01c20;}
+    }
+}
+
+g.unit { 
+    stroke-width: 0; font-weight: bold;
+    font-family: "Ubuntu"; font-size: 1.2em; fill: #1626cf;
+
+    .address {
+    fill: #ffffff; font-size: 0.8em;}
+    .unit-border { 
+    stroke-width: 2px; fill: #a0a0a0;}
+}

=== modified file 'lib/views/templates.handlebars'
--- lib/views/templates.handlebars	2012-08-30 22:46:00 +0000
+++ lib/views/templates.handlebars	2012-09-07 14:59:56 +0000
@@ -1,6 +1,6 @@
 /*
  * Generated code -- lib/views/templates.handlebars
-*/
+ */
 YUI.add('juju-templates', function (Y) {
 
     var Templates = Y.namespace('juju.views').Templates = {};
@@ -10,7 +10,7 @@
   {{/templates}}
 
   {{#partials}}
-    Y.Handlebars.registerPartial'({{{name}}}', 
+    Y.Handlebars.registerPartial'({{{name}}}',
             Y.Handlebars.template({{{template}}});
   {{/partials}}
 

=== modified file 'manifest.json'
--- manifest.json	2012-09-07 09:02:42 +0000
+++ manifest.json	2012-09-10 08:45:43 +0000
@@ -18,7 +18,6 @@
   },
   "permissions": [
     "unlimitedStorage",
-    "notifications",
-    "*"
+    "notifications"
   ]
 }

=== modified file 'package.json'
--- package.json	2012-09-04 16:15:50 +0000
+++ package.json	2012-09-07 20:19:19 +0000
@@ -17,12 +17,13 @@
   "devDependencies": {
     "d3": "> 2.9.5",
     "yui": ">=3.6.0",
-    "mocha": "0.14.0",
+    "mocha": "1.4.2",
     "express": "3.x",
     "expect.js": "0.1.2",
     "should": ">=1.0.0",
     "chai": ">=1.2.0",
-    "less": "1.3.x"
+    "less": "1.3.x",
+    "jshint": ">=0.9.0"
   },
   "optionalDependencies": {}
 }

=== modified file 'server.js'
--- server.js	2012-08-24 20:08:54 +0000
+++ server.js	2012-09-07 14:35:08 +0000
@@ -1,9 +1,11 @@
 #!/usr/bin/node
 
+"use strict";
+
 var server = require("./lib/server.js"),
     config = require("./config").config.server;
 
-port = config["port"] || process.env.PORT || 8888;
+var port = config.port || process.env.PORT || 8888;
 
 server.server.listen(port, function () {
     console.log('Server listening on ' + port);

=== added symlink 'test/assets/mocha.css'
=== target is '../../node_modules/mocha/mocha.css'
=== removed file 'test/assets/mocha.css'
--- test/assets/mocha.css	2012-08-20 21:34:23 +0000
+++ test/assets/mocha.css	1970-01-01 00:00:00 +0000
@@ -1,199 +0,0 @@
-@charset "UTF-8";
-body {
-  font: 20px/1.5 "Helvetica Neue", Helvetica, Arial, sans-serif;
-  padding: 60px 50px;
-}
-
-#mocha ul, #mocha li {
-  margin: 0;
-  padding: 0;
-}
-
-#mocha ul {
-  list-style: none;
-}
-
-#mocha h1, #mocha h2 {
-  margin: 0;
-}
-
-#mocha h1 {
-  margin-top: 15px;
-  font-size: 1em;
-  font-weight: 200;
-}
-
-#mocha h1 a {
-  text-decoration: none;
-  color: inherit;
-}
-
-#mocha h1 a:hover {
-  text-decoration: underline;
-}
-
-#mocha .suite .suite h1 {
-  margin-top: 0;
-  font-size: .8em;
-}
-
-#mocha h2 {
-  font-size: 12px;
-  font-weight: normal;
-  cursor: pointer;
-}
-
-#mocha .suite {
-  margin-left: 15px;
-}
-
-#mocha .test {
-  margin-left: 15px;
-}
-
-#mocha .test:hover h2::after {
-  position: relative;
-  top: 0;
-  right: -10px;
-  content: '(view source)';
-  font-size: 12px;
-  font-family: arial;
-  color: #888;
-}
-
-#mocha .test.pending:hover h2::after {
-  content: '(pending)';
-  font-family: arial;
-}
-
-#mocha .test.pass.medium .duration {
-  background: #C09853;
-}
-
-#mocha .test.pass.slow .duration {
-  background: #B94A48;
-}
-
-#mocha .test.pass::before {
-  content: '✓';
-  font-size: 12px;
-  display: block;
-  float: left;
-  margin-right: 5px;
-  color: #00d6b2;
-}
-
-#mocha .test.pass .duration {
-  font-size: 9px;
-  margin-left: 5px;
-  padding: 2px 5px;
-  color: white;
-  -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.2);
-  -moz-box-shadow: inset 0 1px 1px rgba(0,0,0,.2);
-  box-shadow: inset 0 1px 1px rgba(0,0,0,.2);
-  -webkit-border-radius: 5px;
-  -moz-border-radius: 5px;
-  -ms-border-radius: 5px;
-  -o-border-radius: 5px;
-  border-radius: 5px;
-}
-
-#mocha .test.pass.fast .duration {
-  display: none;
-}
-
-#mocha .test.pending {
-  color: #0b97c4;
-}
-
-#mocha .test.pending::before {
-  content: '◦';
-  color: #0b97c4;
-}
-
-#mocha .test.fail {
-  color: #c00;
-}
-
-#mocha .test.fail pre {
-  color: black;
-}
-
-#mocha .test.fail::before {
-  content: '✖';
-  font-size: 12px;
-  display: block;
-  float: left;
-  margin-right: 5px;
-  color: #c00;
-}
-
-#mocha .test pre.error {
-  color: #c00;
-}
-
-#mocha .test pre {
-  display: inline-block;
-  font: 12px/1.5 monaco, monospace;
-  margin: 5px;
-  padding: 15px;
-  border: 1px solid #eee;
-  border-bottom-color: #ddd;
-  -webkit-border-radius: 3px;
-  -webkit-box-shadow: 0 1px 3px #eee;
-}
-
-#report.pass .test.fail {
-  display: none;
-}
-
-#report.fail .test.pass {
-  display: none;
-}
-
-#error {
-  color: #c00;
-  font-size: 1.5  em;
-  font-weight: 100;
-  letter-spacing: 1px;
-}
-
-#stats {
-  position: fixed;
-  top: 15px;
-  right: 10px;
-  font-size: 12px;
-  margin: 0;
-  color: #888;
-}
-
-#stats .progress {
-  float: right;
-  padding-top: 0;
-}
-
-#stats em {
-  color: black;
-}
-
-#stats a {
-  text-decoration: none;
-  color: inherit;
-}
-
-#stats a:hover {
-  border-bottom: 1px solid #eee;
-}
-
-#stats li {
-  display: inline-block;
-  margin: 0 5px;
-  list-style: none;
-  padding-top: 11px;
-}
-
-code .comment { color: #ddd }
-code .init { color: #2F6FAD }
-code .string { color: #5890AD }
-code .keyword { color: #8A6343 }
-code .number { color: #2F6FAD }

=== removed file 'test/assets/mocha.js'
--- test/assets/mocha.js	2012-08-20 21:34:23 +0000
+++ test/assets/mocha.js	1970-01-01 00:00:00 +0000
@@ -1,4614 +0,0 @@
-;(function(){
-
-
-// CommonJS require()
-
-function require(p){
-    var path = require.resolve(p)
-      , mod = require.modules[path];
-    if (!mod) throw new Error('failed to require "' + p + '"');
-    if (!mod.exports) {
-      mod.exports = {};
-      mod.call(mod.exports, mod, mod.exports, require.relative(path));
-    }
-    return mod.exports;
-  }
-
-require.modules = {};
-
-require.resolve = function (path){
-    var orig = path
-      , reg = path + '.js'
-      , index = path + '/index.js';
-    return require.modules[reg] && reg
-      || require.modules[index] && index
-      || orig;
-  };
-
-require.register = function (path, fn){
-    require.modules[path] = fn;
-  };
-
-require.relative = function (parent) {
-    return function(p){
-      if ('.' != p.charAt(0)) return require(p);
-      
-      var path = parent.split('/')
-        , segs = p.split('/');
-      path.pop();
-      
-      for (var i = 0; i < segs.length; i++) {
-        var seg = segs[i];
-        if ('..' == seg) path.pop();
-        else if ('.' != seg) path.push(seg);
-      }
-
-      return require(path.join('/'));
-    };
-  };
-
-
-require.register("browser/debug.js", function(module, exports, require){
-
-module.exports = function(type){
-  return function(){
-    
-  }
-};
-}); // module: browser/debug.js
-
-require.register("browser/diff.js", function(module, exports, require){
-
-}); // module: browser/diff.js
-
-require.register("browser/events.js", function(module, exports, require){
-
-/**
- * Module exports.
- */
-
-exports.EventEmitter = EventEmitter;
-
-/**
- * Check if `obj` is an array.
- */
-
-function isArray(obj) {
-  return '[object Array]' == {}.toString.call(obj);
-}
-
-/**
- * Event emitter constructor.
- *
- * @api public
- */
-
-function EventEmitter(){};
-
-/**
- * Adds a listener.
- *
- * @api public
- */
-
-EventEmitter.prototype.on = function (name, fn) {
-  if (!this.$events) {
-    this.$events = {};
-  }
-
-  if (!this.$events[name]) {
-    this.$events[name] = fn;
-  } else if (isArray(this.$events[name])) {
-    this.$events[name].push(fn);
-  } else {
-    this.$events[name] = [this.$events[name], fn];
-  }
-
-  return this;
-};
-
-EventEmitter.prototype.addListener = EventEmitter.prototype.on;
-
-/**
- * Adds a volatile listener.
- *
- * @api public
- */
-
-EventEmitter.prototype.once = function (name, fn) {
-  var self = this;
-
-  function on () {
-    self.removeListener(name, on);
-    fn.apply(this, arguments);
-  };
-
-  on.listener = fn;
-  this.on(name, on);
-
-  return this;
-};
-
-/**
- * Removes a listener.
- *
- * @api public
- */
-
-EventEmitter.prototype.removeListener = function (name, fn) {
-  if (this.$events && this.$events[name]) {
-    var list = this.$events[name];
-
-    if (isArray(list)) {
-      var pos = -1;
-
-      for (var i = 0, l = list.length; i < l; i++) {
-        if (list[i] === fn || (list[i].listener && list[i].listener === fn)) {
-          pos = i;
-          break;
-        }
-      }
-
-      if (pos < 0) {
-        return this;
-      }
-
-      list.splice(pos, 1);
-
-      if (!list.length) {
-        delete this.$events[name];
-      }
-    } else if (list === fn || (list.listener && list.listener === fn)) {
-      delete this.$events[name];
-    }
-  }
-
-  return this;
-};
-
-/**
- * Removes all listeners for an event.
- *
- * @api public
- */
-
-EventEmitter.prototype.removeAllListeners = function (name) {
-  if (name === undefined) {
-    this.$events = {};
-    return this;
-  }
-
-  if (this.$events && this.$events[name]) {
-    this.$events[name] = null;
-  }
-
-  return this;
-};
-
-/**
- * Gets all listeners for a certain event.
- *
- * @api public
- */
-
-EventEmitter.prototype.listeners = function (name) {
-  if (!this.$events) {
-    this.$events = {};
-  }
-
-  if (!this.$events[name]) {
-    this.$events[name] = [];
-  }
-
-  if (!isArray(this.$events[name])) {
-    this.$events[name] = [this.$events[name]];
-  }
-
-  return this.$events[name];
-};
-
-/**
- * Emits an event.
- *
- * @api public
- */
-
-EventEmitter.prototype.emit = function (name) {
-  if (!this.$events) {
-    return false;
-  }
-
-  var handler = this.$events[name];
-
-  if (!handler) {
-    return false;
-  }
-
-  var args = [].slice.call(arguments, 1);
-
-  if ('function' == typeof handler) {
-    handler.apply(this, args);
-  } else if (isArray(handler)) {
-    var listeners = handler.slice();
-
-    for (var i = 0, l = listeners.length; i < l; i++) {
-      listeners[i].apply(this, args);
-    }
-  } else {
-    return false;
-  }
-
-  return true;
-};
-}); // module: browser/events.js
-
-require.register("browser/fs.js", function(module, exports, require){
-
-}); // module: browser/fs.js
-
-require.register("browser/path.js", function(module, exports, require){
-
-}); // module: browser/path.js
-
-require.register("browser/progress.js", function(module, exports, require){
-
-/**
- * Expose `Progress`.
- */
-
-module.exports = Progress;
-
-/**
- * Initialize a new `Progress` indicator.
- */
-
-function Progress() {
-  this.percent = 0;
-  this.size(0);
-  this.fontSize(11);
-  this.font('helvetica, arial, sans-serif');
-}
-
-/**
- * Set progress size to `n`.
- *
- * @param {Number} n
- * @return {Progress} for chaining
- * @api public
- */
-
-Progress.prototype.size = function(n){
-  this._size = n;
-  return this;
-};
-
-/**
- * Set text to `str`.
- *
- * @param {String} str
- * @return {Progress} for chaining
- * @api public
- */
-
-Progress.prototype.text = function(str){
-  this._text = str;
-  return this;
-};
-
-/**
- * Set font size to `n`.
- *
- * @param {Number} n
- * @return {Progress} for chaining
- * @api public
- */
-
-Progress.prototype.fontSize = function(n){
-  this._fontSize = n;
-  return this;
-};
-
-/**
- * Set font `family`.
- *
- * @param {String} family
- * @return {Progress} for chaining
- */
-
-Progress.prototype.font = function(family){
-  this._font = family;
-  return this;
-};
-
-/**
- * Update percentage to `n`.
- *
- * @param {Number} n
- * @return {Progress} for chaining
- */
-
-Progress.prototype.update = function(n){
-  this.percent = n;
-  return this;
-};
-
-/**
- * Draw on `ctx`.
- *
- * @param {CanvasRenderingContext2d} ctx
- * @return {Progress} for chaining
- */
-
-Progress.prototype.draw = function(ctx){
-  var percent = Math.min(this.percent, 100)
-    , size = this._size
-    , half = size / 2
-    , x = half
-    , y = half
-    , rad = half - 1
-    , fontSize = this._fontSize;
-
-  ctx.font = fontSize + 'px ' + this._font;
-
-  var angle = Math.PI * 2 * (percent / 100);
-  ctx.clearRect(0, 0, size, size);
-
-  // outer circle
-  ctx.strokeStyle = '#9f9f9f';
-  ctx.beginPath();
-  ctx.arc(x, y, rad, 0, angle, false);
-  ctx.stroke();
-
-  // inner circle
-  ctx.strokeStyle = '#eee';
-  ctx.beginPath();
-  ctx.arc(x, y, rad - 1, 0, angle, true);
-  ctx.stroke();
-
-  // text
-  var text = this._text || (percent | 0) + '%'
-    , w = ctx.measureText(text).width;
-
-  ctx.fillText(
-      text
-    , x - w / 2 + 1
-    , y + fontSize / 2 - 1);
-
-  return this;
-};
-
-}); // module: browser/progress.js
-
-require.register("browser/tty.js", function(module, exports, require){
-
-exports.isatty = function(){
-  return true;
-};
-
-exports.getWindowSize = function(){
-  return [window.innerHeight, window.innerWidth];
-};
-}); // module: browser/tty.js
-
-require.register("context.js", function(module, exports, require){
-
-/**
- * Expose `Context`.
- */
-
-module.exports = Context;
-
-/**
- * Initialize a new `Context`.
- *
- * @api private
- */
-
-function Context(){}
-
-/**
- * Set or get the context `Runnable` to `runnable`.
- *
- * @param {Runnable} runnable
- * @return {Context}
- * @api private
- */
-
-Context.prototype.runnable = function(runnable){
-  if (0 == arguments.length) return this._runnable;
-  this.test = this._runnable = runnable;
-  return this;
-};
-
-/**
- * Set test timeout `ms`.
- *
- * @param {Number} ms
- * @return {Context} self
- * @api private
- */
-
-Context.prototype.timeout = function(ms){
-  this.runnable().timeout(ms);
-  return this;
-};
-
-/**
- * Inspect the context void of `._runnable`.
- *
- * @return {String}
- * @api private
- */
-
-Context.prototype.inspect = function(){
-  return JSON.stringify(this, function(key, val){
-    if ('_runnable' == key) return;
-    if ('test' == key) return;
-    return val;
-  }, 2);
-};
-
-}); // module: context.js
-
-require.register("hook.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Runnable = require('./runnable');
-
-/**
- * Expose `Hook`.
- */
-
-module.exports = Hook;
-
-/**
- * Initialize a new `Hook` with the given `title` and callback `fn`.
- *
- * @param {String} title
- * @param {Function} fn
- * @api private
- */
-
-function Hook(title, fn) {
-  Runnable.call(this, title, fn);
-  this.type = 'hook';
-}
-
-/**
- * Inherit from `Runnable.prototype`.
- */
-
-Hook.prototype = new Runnable;
-Hook.prototype.constructor = Hook;
-
-
-/**
- * Get or set the test `err`.
- *
- * @param {Error} err
- * @return {Error}
- * @api public
- */
-
-Hook.prototype.error = function(err){
-  if (0 == arguments.length) {
-    var err = this._error;
-    this._error = null;
-    return err;
-  }
-
-  this._error = err;
-};
-
-
-}); // module: hook.js
-
-require.register("interfaces/bdd.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Suite = require('../suite')
-  , Test = require('../test');
-
-/**
- * BDD-style interface:
- * 
- *      describe('Array', function(){
- *        describe('#indexOf()', function(){
- *          it('should return -1 when not present', function(){
- *
- *          });
- *
- *          it('should return the index when present', function(){
- *
- *          });
- *        });
- *      });
- * 
- */
-
-module.exports = function(suite){
-  var suites = [suite];
-
-  suite.on('pre-require', function(context){
-
-    /**
-     * Execute before running tests.
-     */
-
-    context.before = function(fn){
-      suites[0].beforeAll(fn);
-    };
-
-    /**
-     * Execute after running tests.
-     */
-
-    context.after = function(fn){
-      suites[0].afterAll(fn);
-    };
-
-    /**
-     * Execute before each test case.
-     */
-
-    context.beforeEach = function(fn){
-      suites[0].beforeEach(fn);
-    };
-
-    /**
-     * Execute after each test case.
-     */
-
-    context.afterEach = function(fn){
-      suites[0].afterEach(fn);
-    };
-
-    /**
-     * Pending describe.
-     */
-
-    context.xdescribe = context.xcontext = function(title, fn){
-      var suite = Suite.create(suites[0], title);
-      suite.pending = true;
-      suites.unshift(suite);
-      fn();
-      suites.shift();
-    };
-
-    /**
-     * Describe a "suite" with the given `title`
-     * and callback `fn` containing nested suites
-     * and/or tests.
-     */
-  
-    context.describe = context.context = function(title, fn){
-      var suite = Suite.create(suites[0], title);
-      suites.unshift(suite);
-      fn();
-      suites.shift();
-    };
-
-    /**
-     * Describe a specification or test-case
-     * with the given `title` and callback `fn`
-     * acting as a thunk.
-     */
-
-    context.it = context.specify = function(title, fn){
-      var suite = suites[0];
-      if (suite.pending) var fn = null;
-      suite.addTest(new Test(title, fn));
-    };
-
-    /**
-     * Pending test case.
-     */
-
-    context.xit = context.xspecify = function(title){
-      context.it(title);
-    };
-  });
-};
-
-}); // module: interfaces/bdd.js
-
-require.register("interfaces/exports.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Suite = require('../suite')
-  , Test = require('../test');
-
-/**
- * TDD-style interface:
- * 
- *     exports.Array = {
- *       '#indexOf()': {
- *         'should return -1 when the value is not present': function(){
- *           
- *         },
- *
- *         'should return the correct index when the value is present': function(){
- *           
- *         }
- *       }
- *     };
- * 
- */
-
-module.exports = function(suite){
-  var suites = [suite];
-
-  suite.on('require', visit);
-
-  function visit(obj) {
-    var suite;
-    for (var key in obj) {
-      if ('function' == typeof obj[key]) {
-        var fn = obj[key];
-        switch (key) {
-          case 'before':
-            suites[0].beforeAll(fn);
-            break;
-          case 'after':
-            suites[0].afterAll(fn);
-            break;
-          case 'beforeEach':
-            suites[0].beforeEach(fn);
-            break;
-          case 'afterEach':
-            suites[0].afterEach(fn);
-            break;
-          default:
-            suites[0].addTest(new Test(key, fn));
-        }
-      } else {
-        var suite = Suite.create(suites[0], key);
-        suites.unshift(suite);
-        visit(obj[key]);
-        suites.shift();
-      }
-    }
-  }
-};
-}); // module: interfaces/exports.js
-
-require.register("interfaces/index.js", function(module, exports, require){
-
-exports.bdd = require('./bdd');
-exports.tdd = require('./tdd');
-exports.qunit = require('./qunit');
-exports.exports = require('./exports');
-
-}); // module: interfaces/index.js
-
-require.register("interfaces/qunit.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Suite = require('../suite')
-  , Test = require('../test');
-
-/**
- * QUnit-style interface:
- * 
- *     suite('Array');
- *     
- *     test('#length', function(){
- *       var arr = [1,2,3];
- *       ok(arr.length == 3);
- *     });
- *     
- *     test('#indexOf()', function(){
- *       var arr = [1,2,3];
- *       ok(arr.indexOf(1) == 0);
- *       ok(arr.indexOf(2) == 1);
- *       ok(arr.indexOf(3) == 2);
- *     });
- *     
- *     suite('String');
- *     
- *     test('#length', function(){
- *       ok('foo'.length == 3);
- *     });
- * 
- */
-
-module.exports = function(suite){
-  var suites = [suite];
-
-  suite.on('pre-require', function(context){
-
-    /**
-     * Execute before running tests.
-     */
-
-    context.before = function(fn){
-      suites[0].beforeAll(fn);
-    };
-
-    /**
-     * Execute after running tests.
-     */
-
-    context.after = function(fn){
-      suites[0].afterAll(fn);
-    };
-
-    /**
-     * Execute before each test case.
-     */
-
-    context.beforeEach = function(fn){
-      suites[0].beforeEach(fn);
-    };
-
-    /**
-     * Execute after each test case.
-     */
-
-    context.afterEach = function(fn){
-      suites[0].afterEach(fn);
-    };
-
-    /**
-     * Describe a "suite" with the given `title`.
-     */
-  
-    context.suite = function(title){
-      if (suites.length > 1) suites.shift();
-      var suite = Suite.create(suites[0], title);
-      suites.unshift(suite);
-    };
-
-    /**
-     * Describe a specification or test-case
-     * with the given `title` and callback `fn`
-     * acting as a thunk.
-     */
-
-    context.test = function(title, fn){
-      suites[0].addTest(new Test(title, fn));
-    };
-  });
-};
-
-}); // module: interfaces/qunit.js
-
-require.register("interfaces/tdd.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Suite = require('../suite')
-  , Test = require('../test');
-
-/**
- * TDD-style interface:
- *
- *      suite('Array', function(){
- *        suite('#indexOf()', function(){
- *          suiteSetup(function(){
- *
- *          });
- *          
- *          test('should return -1 when not present', function(){
- *
- *          });
- *
- *          test('should return the index when present', function(){
- *
- *          });
- *
- *          suiteTeardown(function(){
- *
- *          });
- *        });
- *      });
- *
- */
-
-module.exports = function(suite){
-  var suites = [suite];
-
-  suite.on('pre-require', function(context){
-
-    /**
-     * Execute before each test case.
-     */
-
-    context.setup = function(fn){
-      suites[0].beforeEach(fn);
-    };
-
-    /**
-     * Execute after each test case.
-     */
-
-    context.teardown = function(fn){
-      suites[0].afterEach(fn);
-    };
-
-    /**
-     * Execute before the suite.
-     */
-
-    context.suiteSetup = function(fn){
-      suites[0].beforeAll(fn);
-    };
-
-    /**
-     * Execute after the suite.
-     */
-
-    context.suiteTeardown = function(fn){
-      suites[0].afterAll(fn);
-    };
-
-    /**
-     * Describe a "suite" with the given `title`
-     * and callback `fn` containing nested suites
-     * and/or tests.
-     */
-
-    context.suite = function(title, fn){
-      var suite = Suite.create(suites[0], title);
-      suites.unshift(suite);
-      fn();
-      suites.shift();
-    };
-
-    /**
-     * Describe a specification or test-case
-     * with the given `title` and callback `fn`
-     * acting as a thunk.
-     */
-
-    context.test = function(title, fn){
-      suites[0].addTest(new Test(title, fn));
-    };
-  });
-};
-
-}); // module: interfaces/tdd.js
-
-require.register("mocha.js", function(module, exports, require){
-/*!
- * mocha
- * Copyright(c) 2011 TJ Holowaychuk <tj@vision-media.ca>
- * MIT Licensed
- */
-
-/**
- * Module dependencies.
- */
-
-var path = require('browser/path');
-
-/**
- * Expose `Mocha`.
- */
-
-exports = module.exports = Mocha;
-
-/**
- * Expose internals.
- */
-
-exports.utils = require('./utils');
-exports.interfaces = require('./interfaces');
-exports.reporters = require('./reporters');
-exports.Runnable = require('./runnable');
-exports.Context = require('./context');
-exports.Runner = require('./runner');
-exports.Suite = require('./suite');
-exports.Hook = require('./hook');
-exports.Test = require('./test');
-
-/**
- * Return image `name` path.
- *
- * @param {String} name
- * @return {String}
- * @api private
- */
-
-function image(name) {
-  return __dirname + '/../images/' + name + '.png';
-}
-
-/**
- * Setup mocha with `options`.
- *
- * Options:
- *
- *   - `ui` name "bdd", "tdd", "exports" etc
- *   - `reporter` reporter instance, defaults to `mocha.reporters.Dot`
- *   - `globals` array of accepted globals
- *   - `timeout` timeout in milliseconds
- *   - `ignoreLeaks` ignore global leaks
- *   - `grep` string or regexp to filter tests with
- *
- * @param {Object} options
- * @api public
- */
-
-function Mocha(options) {
-  options = options || {};
-  this.files = [];
-  this.options = options;
-  this.grep(options.grep);
-  this.suite = new exports.Suite('', new exports.Context);
-  this.ui(options.ui);
-  this.reporter(options.reporter);
-  if (options.timeout) this.suite.timeout(options.timeout);
-}
-
-/**
- * Add test `file`.
- *
- * @param {String} file
- * @api public
- */
-
-Mocha.prototype.addFile = function(file){
-  this.files.push(file);
-  return this;
-};
-
-/**
- * Set reporter to `name`, defaults to "dot".
- *
- * @param {String} name
- * @api public
- */
-
-Mocha.prototype.reporter = function(name){
-  name = name || 'dot';
-  this._reporter = require('./reporters/' + name);
-  if (!this._reporter) throw new Error('invalid reporter "' + name + '"');
-  return this;
-};
-
-/**
- * Set test UI `name`, defaults to "bdd".
- *
- * @param {String} bdd
- * @api public
- */
-
-Mocha.prototype.ui = function(name){
-  name = name || 'bdd';
-  this._ui = exports.interfaces[name];
-  if (!this._ui) throw new Error('invalid interface "' + name + '"');
-  this._ui = this._ui(this.suite);
-  return this;
-};
-
-/**
- * Load registered files.
- *
- * @api private
- */
-
-Mocha.prototype.loadFiles = function(fn){
-  var suite = this.suite;
-  var pending = this.files.length;
-  this.files.forEach(function(file){
-    file = path.resolve(file);
-    suite.emit('pre-require', global, file);
-    suite.emit('require', require(file), file);
-    suite.emit('post-require', global, file);
-    --pending || (fn && fn());
-  });
-};
-
-/**
- * Enable growl support.
- *
- * @api private
- */
-
-Mocha.prototype._growl = function(runner, reporter) {
-  var notify = require('growl');
-
-  runner.on('end', function(){
-    var stats = reporter.stats;
-    if (stats.failures) {
-      var msg = stats.failures + ' of ' + runner.total + ' tests failed';
-      notify(msg, { name: 'mocha', title: 'Failed', image: image('error') });
-    } else {
-      notify(stats.passes + ' tests passed in ' + stats.duration + 'ms', {
-          name: 'mocha'
-        , title: 'Passed'
-        , image: image('ok')
-      });
-    }
-  });
-};
-
-/**
- * Add regexp to grep for to the options object
- *
- * @param {RegExp} or {String} re
- * @return {Mocha}
- * @api public
- */
-
-Mocha.prototype.grep = function(re){
-  this.options.grep = 'string' == typeof re
-    ? new RegExp(re)
-    : re;
-  return this;
-};
-
-/**
- * Invert `.grep()` matches.
- *
- * @return {Mocha}
- * @api public
- */
-
-Mocha.prototype.invert = function(){
-  this.options.invert = true;
-  return this;
-};
-
-/**
- * Ignore global leaks.
- *
- * @return {Mocha}
- * @api public
- */
-
-Mocha.prototype.ignoreLeaks = function(){
-  this.options.ignoreLeaks = true;
-  return this;
-};
-
-/**
- * Enable growl support.
- *
- * @return {Mocha}
- * @api public
- */
-
-Mocha.prototype.growl = function(){
-  this.options.growl = true;
-  return this;
-};
-
-/**
- * Ignore `globals`.
- *
- * @param {Array} globals
- * @return {Mocha}
- * @api public
- */
-
-Mocha.prototype.globals = function(globals){
-  this.options.globals = globals;
-  return this;
-};
-
-/**
- * Run tests and invoke `fn()` when complete.
- *
- * @param {Function} fn
- * @return {Runner}
- * @api public
- */
-
-Mocha.prototype.run = function(fn){
-  this.loadFiles();
-  var suite = this.suite;
-  var options = this.options;
-  var runner = new exports.Runner(suite);
-  var reporter = new this._reporter(runner);
-  runner.ignoreLeaks = options.ignoreLeaks;
-  if (options.grep) runner.grep(options.grep, options.invert);
-  if (options.globals) runner.globals(options.globals);
-  if (options.growl) this._growl(runner, reporter);
-  return runner.run(fn);
-};
-
-}); // module: mocha.js
-
-require.register("reporters/base.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var tty = require('browser/tty')
-  , diff = require('browser/diff');
-
-/**
- * Save timer references to avoid Sinon interfering (see GH-237).
- */
-
-var Date = global.Date
-  , setTimeout = global.setTimeout
-  , setInterval = global.setInterval
-  , clearTimeout = global.clearTimeout
-  , clearInterval = global.clearInterval;
-
-/**
- * Check if both stdio streams are associated with a tty.
- */
-
-var isatty = tty.isatty(1) && tty.isatty(2);
-
-/**
- * Expose `Base`.
- */
-
-exports = module.exports = Base;
-
-/**
- * Enable coloring by default.
- */
-
-exports.useColors = isatty;
-
-/**
- * Default color map.
- */
-
-exports.colors = {
-    'pass': 90
-  , 'fail': 31
-  , 'bright pass': 92
-  , 'bright fail': 91
-  , 'bright yellow': 93
-  , 'pending': 36
-  , 'suite': 0
-  , 'error title': 0
-  , 'error message': 31
-  , 'error stack': 90
-  , 'checkmark': 32
-  , 'fast': 90
-  , 'medium': 33
-  , 'slow': 31
-  , 'green': 32
-  , 'light': 90
-  , 'diff gutter': 90
-  , 'diff added': 42
-  , 'diff removed': 41
-};
-
-/**
- * Color `str` with the given `type`,
- * allowing colors to be disabled,
- * as well as user-defined color
- * schemes.
- *
- * @param {String} type
- * @param {String} str
- * @return {String}
- * @api private
- */
-
-var color = exports.color = function(type, str) {
-  if (!exports.useColors) return str;
-  return '\u001b[' + exports.colors[type] + 'm' + str + '\u001b[0m';
-};
-
-/**
- * Expose term window size, with some
- * defaults for when stderr is not a tty.
- */
-
-exports.window = {
-  width: isatty
-    ? process.stdout.getWindowSize
-      ? process.stdout.getWindowSize(1)[0]
-      : tty.getWindowSize()[1]
-    : 75
-};
-
-/**
- * Expose some basic cursor interactions
- * that are common among reporters.
- */
-
-exports.cursor = {
-  hide: function(){
-    process.stdout.write('\u001b[?25l');
-  },
-
-  show: function(){
-    process.stdout.write('\u001b[?25h');
-  },
-
-  deleteLine: function(){
-    process.stdout.write('\u001b[2K');
-  },
-
-  beginningOfLine: function(){
-    process.stdout.write('\u001b[0G');
-  },
-
-  CR: function(){
-    exports.cursor.deleteLine();
-    exports.cursor.beginningOfLine();
-  }
-};
-
-/**
- * A test is considered slow if it
- * exceeds the following value in milliseconds.
- */
-
-exports.slow = 75;
-
-/**
- * Outut the given `failures` as a list.
- *
- * @param {Array} failures
- * @api public
- */
-
-exports.list = function(failures){
-  console.error();
-  failures.forEach(function(test, i){
-    // format
-    var fmt = color('error title', '  %s) %s:\n')
-      + color('error message', '     %s')
-      + color('error stack', '\n%s\n');
-
-    // msg
-    var err = test.err
-      , message = err.message || ''
-      , stack = err.stack || message
-      , index = stack.indexOf(message) + message.length
-      , msg = stack.slice(0, index)
-      , actual = err.actual
-      , expected = err.expected;
-
-    // actual / expected diff
-    if ('string' == typeof actual && 'string' == typeof expected) {
-      var len = Math.max(actual.length, expected.length);
-
-      if (len < 20) msg = errorDiff(err, 'Chars');
-      else msg = errorDiff(err, 'Words');
-
-      // linenos
-      var lines = msg.split('\n');
-      if (lines.length > 4) {
-        var width = String(lines.length).length;
-        msg = lines.map(function(str, i){
-          return pad(++i, width) + ' |' + ' ' + str;
-        }).join('\n');
-      }
-
-      // legend
-      msg = '\n'
-        + color('diff removed', 'actual')
-        + ' '
-        + color('diff added', 'expected')
-        + '\n\n'
-        + msg
-        + '\n';
-
-      // indent
-      msg = msg.replace(/^/gm, '      ');
-
-      fmt = color('error title', '  %s) %s:\n%s')
-        + color('error stack', '\n%s\n');
-    }
-
-    // indent stack trace without msg
-    stack = stack.slice(index ? index + 1 : index)
-      .replace(/^/gm, '  ');
-
-    console.error(fmt, (i + 1), test.fullTitle(), msg, stack);
-  });
-};
-
-/**
- * Initialize a new `Base` reporter.
- *
- * All other reporters generally
- * inherit from this reporter, providing
- * stats such as test duration, number
- * of tests passed / failed etc.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Base(runner) {
-  var self = this
-    , stats = this.stats = { suites: 0, tests: 0, passes: 0, pending: 0, failures: 0 }
-    , failures = this.failures = [];
-
-  if (!runner) return;
-  this.runner = runner;
-
-  runner.on('start', function(){
-    stats.start = new Date;
-  });
-
-  runner.on('suite', function(suite){
-    stats.suites = stats.suites || 0;
-    suite.root || stats.suites++;
-  });
-
-  runner.on('test end', function(test){
-    stats.tests = stats.tests || 0;
-    stats.tests++;
-  });
-
-  runner.on('pass', function(test){
-    stats.passes = stats.passes || 0;
-
-    var medium = exports.slow / 2;
-    test.speed = test.duration > exports.slow
-      ? 'slow'
-      : test.duration > medium
-        ? 'medium'
-        : 'fast';
-
-    stats.passes++;
-  });
-
-  runner.on('fail', function(test, err){
-    stats.failures = stats.failures || 0;
-    stats.failures++;
-    test.err = err;
-    failures.push(test);
-  });
-
-  runner.on('end', function(){
-    stats.end = new Date;
-    stats.duration = new Date - stats.start;
-  });
-
-  runner.on('pending', function(){
-    stats.pending++;
-  });
-}
-
-/**
- * Output common epilogue used by many of
- * the bundled reporters.
- *
- * @api public
- */
-
-Base.prototype.epilogue = function(){
-  var stats = this.stats
-    , fmt
-    , tests;
-
-  console.log();
-
-  function pluralize(n) {
-    return 1 == n ? 'test' : 'tests';
-  }
-
-  // failure
-  if (stats.failures) {
-    fmt = color('bright fail', '  ✖')
-      + color('fail', ' %d of %d %s failed')
-      + color('light', ':')
-
-    console.error(fmt,
-      stats.failures,
-      this.runner.total,
-      pluralize(this.runner.total));
-
-    Base.list(this.failures);
-    console.error();
-    return;
-  }
-
-  // pass
-  fmt = color('bright pass', '  ✔')
-    + color('green', ' %d %s complete')
-    + color('light', ' (%dms)');
-
-  console.log(fmt,
-    stats.tests || 0,
-    pluralize(stats.tests),
-    stats.duration);
-
-  // pending
-  if (stats.pending) {
-    fmt = color('pending', '  •')
-      + color('pending', ' %d %s pending');
-
-    console.log(fmt, stats.pending, pluralize(stats.pending));
-  }
-
-  console.log();
-};
-
-/**
- * Pad the given `str` to `len`.
- *
- * @param {String} str
- * @param {String} len
- * @return {String}
- * @api private
- */
-
-function pad(str, len) {
-  str = String(str);
-  return Array(len - str.length + 1).join(' ') + str;
-}
-
-/**
- * Return a character diff for `err`.
- *
- * @param {Error} err
- * @return {String}
- * @api private
- */
-
-function errorDiff(err, type) {
-  return diff['diff' + type](err.actual, err.expected).map(function(str){
-    if (/^(\n+)$/.test(str.value)) str.value = Array(++RegExp.$1.length).join('<newline>');
-    if (str.added) return colorLines('diff added', str.value);
-    if (str.removed) return colorLines('diff removed', str.value);
-    return str.value;
-  }).join('');
-}
-
-/**
- * Color lines for `str`, using the color `name`.
- *
- * @param {String} name
- * @param {String} str
- * @return {String}
- * @api private
- */
-
-function colorLines(name, str) {
-  return str.split('\n').map(function(str){
-    return color(name, str);
-  }).join('\n');
-}
-
-}); // module: reporters/base.js
-
-require.register("reporters/doc.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , utils = require('../utils');
-
-/**
- * Expose `Doc`.
- */
-
-exports = module.exports = Doc;
-
-/**
- * Initialize a new `Doc` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Doc(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , total = runner.total
-    , indents = 2;
-
-  function indent() {
-    return Array(indents).join('  ');
-  }
-
-  runner.on('suite', function(suite){
-    if (suite.root) return;
-    ++indents;
-    console.log('%s<section class="suite">', indent());
-    ++indents;
-    console.log('%s<h1>%s</h1>', indent(), suite.title);
-    console.log('%s<dl>', indent());
-  });
-
-  runner.on('suite end', function(suite){
-    if (suite.root) return;
-    console.log('%s</dl>', indent());
-    --indents;
-    console.log('%s</section>', indent());
-    --indents;
-  });
-
-  runner.on('pass', function(test){
-    console.log('%s  <dt>%s</dt>', indent(), test.title);
-    var code = utils.escape(utils.clean(test.fn.toString()));
-    console.log('%s  <dd><pre><code>%s</code></pre></dd>', indent(), code);
-  });
-}
-
-}); // module: reporters/doc.js
-
-require.register("reporters/dot.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , color = Base.color;
-
-/**
- * Expose `Dot`.
- */
-
-exports = module.exports = Dot;
-
-/**
- * Initialize a new `Dot` matrix test reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Dot(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , width = Base.window.width * .75 | 0
-    , c = '․'
-    , n = 0;
-
-  runner.on('start', function(){
-    process.stdout.write('\n  ');
-  });
-
-  runner.on('pending', function(test){
-    process.stdout.write(color('pending', c));
-  });
-
-  runner.on('pass', function(test){
-    if (++n % width == 0) process.stdout.write('\n  ');
-    if ('slow' == test.speed) {
-      process.stdout.write(color('bright yellow', c));
-    } else {
-      process.stdout.write(color(test.speed, c));
-    }
-  });
-
-  runner.on('fail', function(test, err){
-    if (++n % width == 0) process.stdout.write('\n  ');
-    process.stdout.write(color('fail', c));
-  });
-
-  runner.on('end', function(){
-    console.log();
-    self.epilogue();
-  });
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-Dot.prototype = new Base;
-Dot.prototype.constructor = Dot;
-
-}); // module: reporters/dot.js
-
-require.register("reporters/html-cov.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var JSONCov = require('./json-cov')
-  , fs = require('browser/fs');
-
-/**
- * Expose `HTMLCov`.
- */
-
-exports = module.exports = HTMLCov;
-
-/**
- * Initialize a new `JsCoverage` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function HTMLCov(runner) {
-  var jade = require('jade')
-    , file = __dirname + '/templates/coverage.jade'
-    , str = fs.readFileSync(file, 'utf8')
-    , fn = jade.compile(str, { filename: file })
-    , self = this;
-
-  JSONCov.call(this, runner, false);
-
-  runner.on('end', function(){
-    process.stdout.write(fn({
-        cov: self.cov
-      , coverageClass: coverageClass
-    }));
-  });
-}
-
-/**
- * Return coverage class for `n`.
- *
- * @return {String}
- * @api private
- */
-
-function coverageClass(n) {
-  if (n >= 75) return 'high';
-  if (n >= 50) return 'medium';
-  if (n >= 25) return 'low';
-  return 'terrible';
-}
-}); // module: reporters/html-cov.js
-
-require.register("reporters/html.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , utils = require('../utils')
-  , Progress = require('../browser/progress')
-  , escape = utils.escape;
-
-/**
- * Save timer references to avoid Sinon interfering (see GH-237).
- */
-
-var Date = global.Date
-  , setTimeout = global.setTimeout
-  , setInterval = global.setInterval
-  , clearTimeout = global.clearTimeout
-  , clearInterval = global.clearInterval;
-
-/**
- * Expose `Doc`.
- */
-
-exports = module.exports = HTML;
-
-/**
- * Stats template.
- */
-
-var statsTemplate = '<ul id="stats">'
-  + '<li class="progress"><canvas width="40" height="40"></canvas></li>'
-  + '<li class="passes"><a href="#">passes:</a> <em>0</em></li>'
-  + '<li class="failures"><a href="#">failures:</a> <em>0</em></li>'
-  + '<li class="duration">duration: <em>0</em>s</li>'
-  + '</ul>';
-
-/**
- * Initialize a new `Doc` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function HTML(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , total = runner.total
-    , root = document.getElementById('mocha')
-    , stat = fragment(statsTemplate)
-    , items = stat.getElementsByTagName('li')
-    , passes = items[1].getElementsByTagName('em')[0]
-    , passesLink = items[1].getElementsByTagName('a')[0]
-    , failures = items[2].getElementsByTagName('em')[0]
-    , failuresLink = items[2].getElementsByTagName('a')[0]
-    , duration = items[3].getElementsByTagName('em')[0]
-    , canvas = stat.getElementsByTagName('canvas')[0]
-    , report = fragment('<ul id="report"></ul>')
-    , stack = [report]
-    , progress
-    , ctx
-
-  if (canvas.getContext) {
-    canvas.style.width = canvas.width;
-    canvas.style.height = canvas.height;
-    canvas.width *= devicePixelRatio;
-    canvas.height *= devicePixelRatio;
-    ctx = canvas.getContext('2d');
-    ctx.scale(devicePixelRatio, devicePixelRatio);
-    progress = new Progress;
-  }
-
-  if (!root) return error('#mocha div missing, add it to your document');
-
-  // pass toggle
-  on(passesLink, 'click', function () {
-    var className = /pass/.test(report.className) ? '' : ' pass';
-    report.className = report.className.replace(/fail|pass/g, '') + className;
-  });
-
-  // failure toggle
-  on(failuresLink, 'click', function () {
-    var className = /fail/.test(report.className) ? '' : ' fail';
-    report.className = report.className.replace(/fail|pass/g, '') + className;
-  });
-
-  root.appendChild(stat);
-  root.appendChild(report);
-
-  if (progress) progress.size(40);
-
-  runner.on('suite', function(suite){
-    if (suite.root) return;
-
-    // suite
-    var url = location.protocol + '//' + location.host + location.pathname + '?grep=^' + utils.escapeRegexp(suite.fullTitle());
-    var el = fragment('<li class="suite"><h1><a href="%s">%s</a></h1></li>', url, escape(suite.title));
-
-    // container
-    stack[0].appendChild(el);
-    stack.unshift(document.createElement('ul'));
-    el.appendChild(stack[0]);
-  });
-
-  runner.on('suite end', function(suite){
-    if (suite.root) return;
-    stack.shift();
-  });
-
-  runner.on('fail', function(test, err){
-    if ('hook' == test.type || err.uncaught) runner.emit('test end', test);
-  });
-
-  runner.on('test end', function(test){
-    window.scrollTo(0, document.body.scrollHeight);
-
-    // TODO: add to stats
-    var percent = stats.tests / total * 100 | 0;
-    if (progress) progress.update(percent).draw(ctx);
-
-    // update stats
-    var ms = new Date - stats.start;
-    text(passes, stats.passes);
-    text(failures, stats.failures);
-    text(duration, (ms / 1000).toFixed(2));
-
-    // test
-    if ('passed' == test.state) {
-      var el = fragment('<li class="test pass %e"><h2>%e<span class="duration">%ems</span></h2></li>', test.speed, test.title, test.duration);
-    } else if (test.pending) {
-      var el = fragment('<li class="test pass pending"><h2>%e</h2></li>', test.title);
-    } else {
-      var el = fragment('<li class="test fail"><h2>%e</h2></li>', test.title);
-      var str = test.err.stack || test.err.toString();
-
-      // FF / Opera do not add the message
-      if (!~str.indexOf(test.err.message)) {
-        str = test.err.message + '\n' + str;
-      }
-
-      // <=IE7 stringifies to [Object Error]. Since it can be overloaded, we
-      // check for the result of the stringifying.
-      if ('[object Error]' == str) str = test.err.message;
-
-      // Safari doesn't give you a stack. Let's at least provide a source line.
-      if (!test.err.stack && test.err.sourceURL && test.err.line !== undefined) {
-        str += "\n(" + test.err.sourceURL + ":" + test.err.line + ")";
-      }
-
-      el.appendChild(fragment('<pre class="error">%e</pre>', str));
-    }
-
-    // toggle code
-    // TODO: defer
-    if (!test.pending) {
-      var h2 = el.getElementsByTagName('h2')[0];
-
-      on(h2, 'click', function(){
-        pre.style.display = 'none' == pre.style.display
-          ? 'inline-block'
-          : 'none';
-      });
-
-      var pre = fragment('<pre><code>%e</code></pre>', utils.clean(test.fn.toString()));
-      el.appendChild(pre);
-      pre.style.display = 'none';
-    }
-
-    stack[0].appendChild(el);
-  });
-}
-
-/**
- * Display error `msg`.
- */
-
-function error(msg) {
-  document.body.appendChild(fragment('<div id="error">%s</div>', msg));
-}
-
-/**
- * Return a DOM fragment from `html`.
- */
-
-function fragment(html) {
-  var args = arguments
-    , div = document.createElement('div')
-    , i = 1;
-
-  div.innerHTML = html.replace(/%([se])/g, function(_, type){
-    switch (type) {
-      case 's': return String(args[i++]);
-      case 'e': return escape(args[i++]);
-    }
-  });
-
-  return div.firstChild;
-}
-
-/**
- * Set `el` text to `str`.
- */
-
-function text(el, str) {
-  if (el.textContent) {
-    el.textContent = str;
-  } else {
-    el.innerText = str;
-  }
-}
-
-/**
- * Listen on `event` with callback `fn`.
- */
-
-function on(el, event, fn) {
-  if (el.addEventListener) {
-    el.addEventListener(event, fn, false);
-  } else {
-    el.attachEvent('on' + event, fn);
-  }
-}
-
-}); // module: reporters/html.js
-
-require.register("reporters/index.js", function(module, exports, require){
-
-exports.Base = require('./base');
-exports.Dot = require('./dot');
-exports.Doc = require('./doc');
-exports.TAP = require('./tap');
-exports.JSON = require('./json');
-exports.HTML = require('./html');
-exports.List = require('./list');
-exports.Min = require('./min');
-exports.Spec = require('./spec');
-exports.Nyan = require('./nyan');
-exports.XUnit = require('./xunit');
-exports.Progress = require('./progress');
-exports.Landing = require('./landing');
-exports.JSONCov = require('./json-cov');
-exports.HTMLCov = require('./html-cov');
-exports.JSONStream = require('./json-stream');
-exports.Teamcity = require('./teamcity');
-
-}); // module: reporters/index.js
-
-require.register("reporters/json-cov.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base');
-
-/**
- * Expose `JSONCov`.
- */
-
-exports = module.exports = JSONCov;
-
-/**
- * Initialize a new `JsCoverage` reporter.
- *
- * @param {Runner} runner
- * @param {Boolean} output
- * @api public
- */
-
-function JSONCov(runner, output) {
-  var self = this
-    , output = 1 == arguments.length ? true : output;
-
-  Base.call(this, runner);
-
-  var tests = []
-    , failures = []
-    , passes = [];
-
-  runner.on('test end', function(test){
-    tests.push(test);
-  });
-
-  runner.on('pass', function(test){
-    passes.push(test);
-  });
-
-  runner.on('fail', function(test){
-    failures.push(test);
-  });
-
-  runner.on('end', function(){
-    var cov = global._$jscoverage || {};
-    var result = self.cov = map(cov);
-    result.stats = self.stats;
-    result.tests = tests.map(clean);
-    result.failures = failures.map(clean);
-    result.passes = passes.map(clean);
-    if (!output) return;
-    process.stdout.write(JSON.stringify(result, null, 2 ));
-  });
-}
-
-/**
- * Map jscoverage data to a JSON structure
- * suitable for reporting.
- *
- * @param {Object} cov
- * @return {Object}
- * @api private
- */
-
-function map(cov) {
-  var ret = {
-      instrumentation: 'node-jscoverage'
-    , sloc: 0
-    , hits: 0
-    , misses: 0
-    , coverage: 0
-    , files: []
-  };
-
-  for (var filename in cov) {
-    var data = coverage(filename, cov[filename]);
-    ret.files.push(data);
-    ret.hits += data.hits;
-    ret.misses += data.misses;
-    ret.sloc += data.sloc;
-  }
-
-  if (ret.sloc > 0) {
-    ret.coverage = (ret.hits / ret.sloc) * 100;
-  }
-
-  return ret;
-};
-
-/**
- * Map jscoverage data for a single source file
- * to a JSON structure suitable for reporting.
- *
- * @param {String} filename name of the source file
- * @param {Object} data jscoverage coverage data
- * @return {Object}
- * @api private
- */
-
-function coverage(filename, data) {
-  var ret = {
-    filename: filename,
-    coverage: 0,
-    hits: 0,
-    misses: 0,
-    sloc: 0,
-    source: {}
-  };
-
-  data.source.forEach(function(line, num){
-    num++;
-
-    if (data[num] === 0) {
-      ret.misses++;
-      ret.sloc++;
-    } else if (data[num] !== undefined) {
-      ret.hits++;
-      ret.sloc++;
-    }
-
-    ret.source[num] = {
-        source: line
-      , coverage: data[num] === undefined
-        ? ''
-        : data[num]
-    };
-  });
-
-  ret.coverage = ret.hits / ret.sloc * 100;
-
-  return ret;
-}
-
-/**
- * Return a plain-object representation of `test`
- * free of cyclic properties etc.
- *
- * @param {Object} test
- * @return {Object}
- * @api private
- */
-
-function clean(test) {
-  return {
-      title: test.title
-    , fullTitle: test.fullTitle()
-    , duration: test.duration
-  }
-}
-
-}); // module: reporters/json-cov.js
-
-require.register("reporters/json-stream.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , color = Base.color;
-
-/**
- * Expose `List`.
- */
-
-exports = module.exports = List;
-
-/**
- * Initialize a new `List` test reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function List(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , total = runner.total;
-
-  runner.on('start', function(){
-    console.log(JSON.stringify(['start', { total: total }]));
-  });
-
-  runner.on('pass', function(test){
-    console.log(JSON.stringify(['pass', clean(test)]));
-  });
-
-  runner.on('fail', function(test, err){
-    console.log(JSON.stringify(['fail', clean(test)]));
-  });
-
-  runner.on('end', function(){
-    process.stdout.write(JSON.stringify(['end', self.stats]));
-  });
-}
-
-/**
- * Return a plain-object representation of `test`
- * free of cyclic properties etc.
- *
- * @param {Object} test
- * @return {Object}
- * @api private
- */
-
-function clean(test) {
-  return {
-      title: test.title
-    , fullTitle: test.fullTitle()
-    , duration: test.duration
-  }
-}
-}); // module: reporters/json-stream.js
-
-require.register("reporters/json.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , cursor = Base.cursor
-  , color = Base.color;
-
-/**
- * Expose `JSON`.
- */
-
-exports = module.exports = JSONReporter;
-
-/**
- * Initialize a new `JSON` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function JSONReporter(runner) {
-  var self = this;
-  Base.call(this, runner);
-
-  var tests = []
-    , failures = []
-    , passes = [];
-
-  runner.on('test end', function(test){
-    tests.push(test);
-  });
-
-  runner.on('pass', function(test){
-    passes.push(test);
-  });
-
-  runner.on('fail', function(test){
-    failures.push(test);
-  });
-
-  runner.on('end', function(){
-    var obj = {
-        stats: self.stats
-      , tests: tests.map(clean)
-      , failures: failures.map(clean)
-      , passes: passes.map(clean)
-    };
-
-    process.stdout.write(JSON.stringify(obj, null, 2));
-  });
-}
-
-/**
- * Return a plain-object representation of `test`
- * free of cyclic properties etc.
- *
- * @param {Object} test
- * @return {Object}
- * @api private
- */
-
-function clean(test) {
-  return {
-      title: test.title
-    , fullTitle: test.fullTitle()
-    , duration: test.duration
-  }
-}
-}); // module: reporters/json.js
-
-require.register("reporters/landing.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , cursor = Base.cursor
-  , color = Base.color;
-
-/**
- * Expose `Landing`.
- */
-
-exports = module.exports = Landing;
-
-/**
- * Airplane color.
- */
-
-Base.colors.plane = 0;
-
-/**
- * Airplane crash color.
- */
-
-Base.colors['plane crash'] = 31;
-
-/**
- * Runway color.
- */
-
-Base.colors.runway = 90;
-
-/**
- * Initialize a new `Landing` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Landing(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , width = Base.window.width * .75 | 0
-    , total = runner.total
-    , stream = process.stdout
-    , plane = color('plane', '✈')
-    , crashed = -1
-    , n = 0;
-
-  function runway() {
-    var buf = Array(width).join('-');
-    return '  ' + color('runway', buf);
-  }
-
-  runner.on('start', function(){
-    stream.write('\n  ');
-    cursor.hide();
-  });
-
-  runner.on('test end', function(test){
-    // check if the plane crashed
-    var col = -1 == crashed
-      ? width * ++n / total | 0
-      : crashed;
-
-    // show the crash
-    if ('failed' == test.state) {
-      plane = color('plane crash', '✈');
-      crashed = col;
-    }
-
-    // render landing strip
-    stream.write('\u001b[4F\n\n');
-    stream.write(runway());
-    stream.write('\n  ');
-    stream.write(color('runway', Array(col).join('⋅')));
-    stream.write(plane)
-    stream.write(color('runway', Array(width - col).join('⋅') + '\n'));
-    stream.write(runway());
-    stream.write('\u001b[0m');
-  });
-
-  runner.on('end', function(){
-    cursor.show();
-    console.log();
-    self.epilogue();
-  });
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-Landing.prototype = new Base;
-Landing.prototype.constructor = Landing;
-
-}); // module: reporters/landing.js
-
-require.register("reporters/list.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , cursor = Base.cursor
-  , color = Base.color;
-
-/**
- * Expose `List`.
- */
-
-exports = module.exports = List;
-
-/**
- * Initialize a new `List` test reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function List(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , n = 0;
-
-  runner.on('start', function(){
-    console.log();
-  });
-
-  runner.on('test', function(test){
-    process.stdout.write(color('pass', '    ' + test.fullTitle() + ': '));
-  });
-
-  runner.on('pending', function(test){
-    var fmt = color('checkmark', '  -')
-      + color('pending', ' %s');
-    console.log(fmt, test.fullTitle());
-  });
-
-  runner.on('pass', function(test){
-    var fmt = color('checkmark', '  ✓')
-      + color('pass', ' %s: ')
-      + color(test.speed, '%dms');
-    cursor.CR();
-    console.log(fmt, test.fullTitle(), test.duration);
-  });
-
-  runner.on('fail', function(test, err){
-    cursor.CR();
-    console.log(color('fail', '  %d) %s'), ++n, test.fullTitle());
-  });
-
-  runner.on('end', self.epilogue.bind(self));
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-List.prototype = new Base;
-List.prototype.constructor = List;
-
-
-}); // module: reporters/list.js
-
-require.register("reporters/markdown.js", function(module, exports, require){
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , utils = require('../utils');
-
-/**
- * Expose `Markdown`.
- */
-
-exports = module.exports = Markdown;
-
-/**
- * Initialize a new `Markdown` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Markdown(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , total = runner.total
-    , level = 0
-    , buf = '';
-
-  function title(str) {
-    return Array(level).join('#') + ' ' + str;
-  }
-
-  function indent() {
-    return Array(level).join('  ');
-  }
-
-  function mapTOC(suite, obj) {
-    var ret = obj;
-    obj = obj[suite.title] = obj[suite.title] || { suite: suite };
-    suite.suites.forEach(function(suite){
-      mapTOC(suite, obj);
-    });
-    return ret;
-  }
-
-  function stringifyTOC(obj, level) {
-    ++level;
-    var buf = '';
-    var link;
-    for (var key in obj) {
-      if ('suite' == key) continue;
-      if (key) link = ' - [' + key + '](#' + utils.slug(obj[key].suite.fullTitle()) + ')\n';
-      if (key) buf += Array(level).join('  ') + link;
-      buf += stringifyTOC(obj[key], level);
-    }
-    --level;
-    return buf;
-  }
-
-  function generateTOC(suite) {
-    var obj = mapTOC(suite, {});
-    return stringifyTOC(obj, 0);
-  }
-
-  generateTOC(runner.suite);
-
-  runner.on('suite', function(suite){
-    ++level;
-    var slug = utils.slug(suite.fullTitle());
-    buf += '<a name="' + slug + '" />' + '\n';
-    buf += title(suite.title) + '\n';
-  });
-
-  runner.on('suite end', function(suite){
-    --level;
-  });
-
-  runner.on('pass', function(test){
-    var code = utils.clean(test.fn.toString());
-    buf += test.title + '.\n';
-    buf += '\n```js\n';
-    buf += code + '\n';
-    buf += '```\n\n';
-  });
-
-  runner.on('end', function(){
-    process.stdout.write('# TOC\n');
-    process.stdout.write(generateTOC(runner.suite));
-    process.stdout.write(buf);
-  });
-}
-}); // module: reporters/markdown.js
-
-require.register("reporters/min.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base');
-
-/**
- * Expose `Min`.
- */
-
-exports = module.exports = Min;
-
-/**
- * Initialize a new `Min` minimal test reporter (best used with --watch).
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Min(runner) {
-  Base.call(this, runner);
-  
-  runner.on('start', function(){
-    // clear screen
-    process.stdout.write('\u001b[2J');
-    // set cursor position
-    process.stdout.write('\u001b[1;3H');
-  });
-
-  runner.on('end', this.epilogue.bind(this));
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-Min.prototype = new Base;
-Min.prototype.constructor = Min;
-
-}); // module: reporters/min.js
-
-require.register("reporters/nyan.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , color = Base.color;
-
-/**
- * Expose `Dot`.
- */
-
-exports = module.exports = NyanCat;
-
-/**
- * Initialize a new `Dot` matrix test reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function NyanCat(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , width = Base.window.width * .75 | 0
-    , rainbowColors = this.rainbowColors = self.generateColors()
-    , colorIndex = this.colorIndex = 0
-    , numerOfLines = this.numberOfLines = 4
-    , trajectories = this.trajectories = [[], [], [], []]
-    , nyanCatWidth = this.nyanCatWidth = 11
-    , trajectoryWidthMax = this.trajectoryWidthMax = (width - nyanCatWidth)
-    , scoreboardWidth = this.scoreboardWidth = 5
-    , tick = this.tick = 0
-    , n = 0;
-
-  runner.on('start', function(){
-    Base.cursor.hide();
-    self.draw('start');
-  });
-
-  runner.on('pending', function(test){
-    self.draw('pending');
-  });
-
-  runner.on('pass', function(test){
-    self.draw('pass');
-  });
-
-  runner.on('fail', function(test, err){
-    self.draw('fail');
-  });
-
-  runner.on('end', function(){
-    Base.cursor.show();
-    for (var i = 0; i < self.numberOfLines; i++) write('\n');
-    self.epilogue();
-  });
-}
-
-/**
- * Draw the nyan cat with runner `status`.
- *
- * @param {String} status
- * @api private
- */
-
-NyanCat.prototype.draw = function(status){
-  this.appendRainbow();
-  this.drawScoreboard();
-  this.drawRainbow();
-  this.drawNyanCat(status);
-  this.tick = !this.tick;
-};
-
-/**
- * Draw the "scoreboard" showing the number
- * of passes, failures and pending tests.
- *
- * @api private
- */
-
-NyanCat.prototype.drawScoreboard = function(){
-  var stats = this.stats;
-  var colors = Base.colors;
-
-  function draw(color, n) {
-    write(' ');
-    write('\u001b[' + color + 'm' + n + '\u001b[0m');
-    write('\n');
-  }
-
-  draw(colors.green, stats.passes);
-  draw(colors.fail, stats.failures);
-  draw(colors.pending, stats.pending);
-  write('\n');
-
-  this.cursorUp(this.numberOfLines);
-};
-
-/**
- * Append the rainbow.
- *
- * @api private
- */
-
-NyanCat.prototype.appendRainbow = function(){
-  var segment = this.tick ? '_' : '-';
-  var rainbowified = this.rainbowify(segment);
-
-  for (var index = 0; index < this.numberOfLines; index++) {
-    var trajectory = this.trajectories[index];
-    if (trajectory.length >= this.trajectoryWidthMax) trajectory.shift();
-    trajectory.push(rainbowified);
-  }
-};
-
-/**
- * Draw the rainbow.
- *
- * @api private
- */
-
-NyanCat.prototype.drawRainbow = function(){
-  var self = this;
-
-  this.trajectories.forEach(function(line, index) {
-    write('\u001b[' + self.scoreboardWidth + 'C');
-    write(line.join(''));
-    write('\n');
-  });
-
-  this.cursorUp(this.numberOfLines);
-};
-
-/**
- * Draw the nyan cat with `status`.
- *
- * @param {String} status
- * @api private
- */
-
-NyanCat.prototype.drawNyanCat = function(status) {
-  var self = this;
-  var startWidth = this.scoreboardWidth + this.trajectories[0].length;
-
-  [0, 1, 2, 3].forEach(function(index) {
-    write('\u001b[' + startWidth + 'C');
-
-    switch (index) {
-      case 0:
-        write('_,------,');
-        write('\n');
-        break;
-      case 1:
-        var padding = self.tick ? '  ' : '   ';
-        write('_|' + padding + '/\\_/\\ ');
-        write('\n');
-        break;
-      case 2:
-        var padding = self.tick ? '_' : '__';
-        var tail = self.tick ? '~' : '^';
-        var face;
-        switch (status) {
-          case 'pass':
-            face = '( ^ .^)';
-            break;
-          case 'fail':
-            face = '( o .o)';
-            break;
-          default:
-            face = '( - .-)';
-        }
-        write(tail + '|' + padding + face + ' ');
-        write('\n');
-        break;
-      case 3:
-        var padding = self.tick ? ' ' : '  ';
-        write(padding + '""  "" ');
-        write('\n');
-        break;
-    }
-  });
-
-  this.cursorUp(this.numberOfLines);
-};
-
-/**
- * Move cursor up `n`.
- *
- * @param {Number} n
- * @api private
- */
-
-NyanCat.prototype.cursorUp = function(n) {
-  write('\u001b[' + n + 'A');
-};
-
-/**
- * Move cursor down `n`.
- *
- * @param {Number} n
- * @api private
- */
-
-NyanCat.prototype.cursorDown = function(n) {
-  write('\u001b[' + n + 'B');
-};
-
-/**
- * Generate rainbow colors.
- *
- * @return {Array}
- * @api private
- */
-
-NyanCat.prototype.generateColors = function(){
-  var colors = [];
-
-  for (var i = 0; i < (6 * 7); i++) {
-    var pi3 = Math.floor(Math.PI / 3);
-    var n = (i * (1.0 / 6));
-    var r = Math.floor(3 * Math.sin(n) + 3);
-    var g = Math.floor(3 * Math.sin(n + 2 * pi3) + 3);
-    var b = Math.floor(3 * Math.sin(n + 4 * pi3) + 3);
-    colors.push(36 * r + 6 * g + b + 16);
-  }
-
-  return colors;
-};
-
-/**
- * Apply rainbow to the given `str`.
- *
- * @param {String} str
- * @return {String}
- * @api private
- */
-
-NyanCat.prototype.rainbowify = function(str){
-  var color = this.rainbowColors[this.colorIndex % this.rainbowColors.length];
-  this.colorIndex += 1;
-  return '\u001b[38;5;' + color + 'm' + str + '\u001b[0m';
-};
-
-/**
- * Stdout helper.
- */
-
-function write(string) {
-  process.stdout.write(string);
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-NyanCat.prototype = new Base;
-NyanCat.prototype.constructor = NyanCat;
-
-
-}); // module: reporters/nyan.js
-
-require.register("reporters/progress.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , cursor = Base.cursor
-  , color = Base.color;
-
-/**
- * Expose `Progress`.
- */
-
-exports = module.exports = Progress;
-
-/**
- * General progress bar color.
- */
-
-Base.colors.progress = 90;
-
-/**
- * Initialize a new `Progress` bar test reporter.
- *
- * @param {Runner} runner
- * @param {Object} options
- * @api public
- */
-
-function Progress(runner, options) {
-  Base.call(this, runner);
-
-  var self = this
-    , options = options || {}
-    , stats = this.stats
-    , width = Base.window.width * .50 | 0
-    , total = runner.total
-    , complete = 0
-    , max = Math.max;
-
-  // default chars
-  options.open = options.open || '[';
-  options.complete = options.complete || '▬';
-  options.incomplete = options.incomplete || '⋅';
-  options.close = options.close || ']';
-  options.verbose = false;
-
-  // tests started
-  runner.on('start', function(){
-    console.log();
-    cursor.hide();
-  });
-
-  // tests complete
-  runner.on('test end', function(){
-    complete++;
-    var incomplete = total - complete
-      , percent = complete / total
-      , n = width * percent | 0
-      , i = width - n;
-
-    cursor.CR();
-    process.stdout.write('\u001b[J');
-    process.stdout.write(color('progress', '  ' + options.open));
-    process.stdout.write(Array(n).join(options.complete));
-    process.stdout.write(Array(i).join(options.incomplete));
-    process.stdout.write(color('progress', options.close));
-    if (options.verbose) {
-      process.stdout.write(color('progress', ' ' + complete + ' of ' + total));
-    }
-  });
-
-  // tests are complete, output some stats
-  // and the failures if any
-  runner.on('end', function(){
-    cursor.show();
-    console.log();
-    self.epilogue();
-  });
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-Progress.prototype = new Base;
-Progress.prototype.constructor = Progress;
-
-
-}); // module: reporters/progress.js
-
-require.register("reporters/spec.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , cursor = Base.cursor
-  , color = Base.color;
-
-/**
- * Expose `Spec`.
- */
-
-exports = module.exports = Spec;
-
-/**
- * Initialize a new `Spec` test reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Spec(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , indents = 0
-    , n = 0;
-
-  function indent() {
-    return Array(indents).join('  ')
-  }
-
-  runner.on('start', function(){
-    console.log();
-  });
-
-  runner.on('suite', function(suite){
-    ++indents;
-    console.log(color('suite', '%s%s'), indent(), suite.title);
-  });
-
-  runner.on('suite end', function(suite){
-    --indents;
-    if (1 == indents) console.log();
-  });
-
-  runner.on('test', function(test){
-    process.stdout.write(indent() + color('pass', '  ◦ ' + test.title + ': '));
-  });
-
-  runner.on('pending', function(test){
-    var fmt = indent() + color('pending', '  - %s');
-    console.log(fmt, test.title);
-  });
-
-  runner.on('pass', function(test){
-    if ('fast' == test.speed) {
-      var fmt = indent()
-        + color('checkmark', '  ✓')
-        + color('pass', ' %s ');
-      cursor.CR();
-      console.log(fmt, test.title);
-    } else {
-      var fmt = indent()
-        + color('checkmark', '  ✓')
-        + color('pass', ' %s ')
-        + color(test.speed, '(%dms)');
-      cursor.CR();
-      console.log(fmt, test.title, test.duration);
-    }
-  });
-
-  runner.on('fail', function(test, err){
-    cursor.CR();
-    console.log(indent() + color('fail', '  %d) %s'), ++n, test.title);
-  });
-
-  runner.on('end', self.epilogue.bind(self));
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-Spec.prototype = new Base;
-Spec.prototype.constructor = Spec;
-
-
-}); // module: reporters/spec.js
-
-require.register("reporters/tap.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , cursor = Base.cursor
-  , color = Base.color;
-
-/**
- * Expose `TAP`.
- */
-
-exports = module.exports = TAP;
-
-/**
- * Initialize a new `TAP` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function TAP(runner) {
-  Base.call(this, runner);
-
-  var self = this
-    , stats = this.stats
-    , total = runner.total
-    , n = 1;
-
-  runner.on('start', function(){
-    console.log('%d..%d', 1, total);
-  });
-
-  runner.on('test end', function(){
-    ++n;
-  });
-
-  runner.on('pending', function(test){
-    console.log('ok %d %s # SKIP -', n, title(test));
-  });
-
-  runner.on('pass', function(test){
-    console.log('ok %d %s', n, title(test));
-  });
-
-  runner.on('fail', function(test, err){
-    console.log('not ok %d %s', n, title(test));
-    console.log(err.stack.replace(/^/gm, '  '));
-  });
-}
-
-/**
- * Return a TAP-safe title of `test`
- *
- * @param {Object} test
- * @return {String}
- * @api private
- */
-
-function title(test) {
-  return test.fullTitle().replace(/#/g, '');
-}
-
-}); // module: reporters/tap.js
-
-require.register("reporters/teamcity.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base');
-
-/**
- * Expose `Teamcity`.
- */
-
-exports = module.exports = Teamcity;
-
-/**
- * Initialize a new `Teamcity` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function Teamcity(runner) {
-  Base.call(this, runner);
-  var stats = this.stats;
-
-  runner.on('start', function() {
-    console.log("##teamcity[testSuiteStarted name='mocha.suite']");
-  });
-
-  runner.on('test', function(test) {
-    console.log("##teamcity[testStarted name='" + escape(test.fullTitle()) + "']");
-  });
-
-  runner.on('fail', function(test, err) {
-    console.log("##teamcity[testFailed name='" + escape(test.fullTitle()) + "' message='" + escape(err.message) + "']");
-  });
-
-  runner.on('pending', function(test) {
-    console.log("##teamcity[testIgnored name='" + escape(test.fullTitle()) + "' message='pending']");
-  });
-
-  runner.on('test end', function(test) {
-    console.log("##teamcity[testFinished name='" + escape(test.fullTitle()) + "' duration='" + test.duration + "']");
-  });
-
-  runner.on('end', function() {
-    console.log("##teamcity[testSuiteFinished name='mocha.suite' duration='" + stats.duration + "']");
-  });
-}
-
-/**
- * Escape the given `str`.
- */
-
-function escape(str) {
-  return str
-    .replace(/\|/g, "||")
-    .replace(/\n/g, "|n")
-    .replace(/\r/g, "|r")
-    .replace(/\[/g, "|[")
-    .replace(/\]/g, "|]")
-    .replace(/\u0085/g, "|x")
-    .replace(/\u2028/g, "|l")
-    .replace(/\u2029/g, "|p")
-    .replace(/'/g, "|'");
-}
-
-}); // module: reporters/teamcity.js
-
-require.register("reporters/xunit.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Base = require('./base')
-  , utils = require('../utils')
-  , escape = utils.escape;
-
-/**
- * Save timer references to avoid Sinon interfering (see GH-237).
- */
-
-var Date = global.Date
-  , setTimeout = global.setTimeout
-  , setInterval = global.setInterval
-  , clearTimeout = global.clearTimeout
-  , clearInterval = global.clearInterval;
-
-/**
- * Expose `XUnit`.
- */
-
-exports = module.exports = XUnit;
-
-/**
- * Initialize a new `XUnit` reporter.
- *
- * @param {Runner} runner
- * @api public
- */
-
-function XUnit(runner) {
-  Base.call(this, runner);
-  var stats = this.stats
-    , tests = []
-    , self = this;
-
-  runner.on('pass', function(test){
-    tests.push(test);
-  });
-  
-  runner.on('fail', function(test){
-    tests.push(test);
-  });
-
-  runner.on('end', function(){
-    console.log(tag('testsuite', {
-        name: 'Mocha Tests'
-      , tests: stats.tests
-      , failures: stats.failures
-      , errors: stats.failures
-      , skip: stats.tests - stats.failures - stats.passes
-      , timestamp: (new Date).toUTCString()
-      , time: stats.duration / 1000
-    }, false));
-
-    tests.forEach(test);
-    console.log('</testsuite>');    
-  });
-}
-
-/**
- * Inherit from `Base.prototype`.
- */
-
-XUnit.prototype = new Base;
-XUnit.prototype.constructor = XUnit;
-
-
-/**
- * Output tag for the given `test.`
- */
-
-function test(test) {
-  var attrs = {
-      classname: test.parent.fullTitle()
-    , name: test.title
-    , time: test.duration / 1000
-  };
-
-  if ('failed' == test.state) {
-    var err = test.err;
-    attrs.message = escape(err.message);
-    console.log(tag('testcase', attrs, false, tag('failure', attrs, false, cdata(err.stack))));
-  } else if (test.pending) {
-    console.log(tag('testcase', attrs, false, tag('skipped', {}, true)));
-  } else {
-    console.log(tag('testcase', attrs, true) );
-  }
-}
-
-/**
- * HTML tag helper.
- */
-
-function tag(name, attrs, close, content) {
-  var end = close ? '/>' : '>'
-    , pairs = []
-    , tag;
-
-  for (var key in attrs) {
-    pairs.push(key + '="' + escape(attrs[key]) + '"');
-  }
-
-  tag = '<' + name + (pairs.length ? ' ' + pairs.join(' ') : '') + end;
-  if (content) tag += content + '</' + name + end;
-  return tag;
-}
-
-/**
- * Return cdata escaped CDATA `str`.
- */
-
-function cdata(str) {
-  return '<![CDATA[' + escape(str) + ']]>';
-}
-
-}); // module: reporters/xunit.js
-
-require.register("runnable.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var EventEmitter = require('browser/events').EventEmitter
-  , debug = require('browser/debug')('mocha:runnable');
-
-/**
- * Save timer references to avoid Sinon interfering (see GH-237).
- */
-
-var Date = global.Date
-  , setTimeout = global.setTimeout
-  , setInterval = global.setInterval
-  , clearTimeout = global.clearTimeout
-  , clearInterval = global.clearInterval;
-
-/**
- * Expose `Runnable`.
- */
-
-module.exports = Runnable;
-
-/**
- * Initialize a new `Runnable` with the given `title` and callback `fn`.
- *
- * @param {String} title
- * @param {Function} fn
- * @api private
- */
-
-function Runnable(title, fn) {
-  this.title = title;
-  this.fn = fn;
-  this.async = fn && fn.length;
-  this.sync = ! this.async;
-  this._timeout = 2000;
-  this.timedOut = false;
-}
-
-/**
- * Inherit from `EventEmitter.prototype`.
- */
-
-Runnable.prototype = new EventEmitter;
-Runnable.prototype.constructor = Runnable;
-
-
-/**
- * Set & get timeout `ms`.
- *
- * @param {Number} ms
- * @return {Runnable|Number} ms or self
- * @api private
- */
-
-Runnable.prototype.timeout = function(ms){
-  if (0 == arguments.length) return this._timeout;
-  debug('timeout %d', ms);
-  this._timeout = ms;
-  if (this.timer) this.resetTimeout();
-  return this;
-};
-
-/**
- * Return the full title generated by recursively
- * concatenating the parent's full title.
- *
- * @return {String}
- * @api public
- */
-
-Runnable.prototype.fullTitle = function(){
-  return this.parent.fullTitle() + ' ' + this.title;
-};
-
-/**
- * Clear the timeout.
- *
- * @api private
- */
-
-Runnable.prototype.clearTimeout = function(){
-  clearTimeout(this.timer);
-};
-
-/**
- * Inspect the runnable void of private properties.
- *
- * @return {String}
- * @api private
- */
-
-Runnable.prototype.inspect = function(){
-  return JSON.stringify(this, function(key, val){
-    if ('_' == key[0]) return;
-    if ('parent' == key) return '#<Suite>';
-    if ('ctx' == key) return '#<Context>';
-    return val;
-  }, 2);
-};
-
-/**
- * Reset the timeout.
- *
- * @api private
- */
-
-Runnable.prototype.resetTimeout = function(){
-  var self = this
-    , ms = this.timeout();
-
-  this.clearTimeout();
-  if (ms) {
-    this.timer = setTimeout(function(){
-      self.callback(new Error('timeout of ' + ms + 'ms exceeded'));
-      self.timedOut = true;
-    }, ms);
-  }
-};
-
-/**
- * Run the test and invoke `fn(err)`.
- *
- * @param {Function} fn
- * @api private
- */
-
-Runnable.prototype.run = function(fn){
-  var self = this
-    , ms = this.timeout()
-    , start = new Date
-    , ctx = this.ctx
-    , finished
-    , emitted;
-
-  if (ctx) ctx.runnable(this);
-
-  // timeout
-  if (this.async) {
-    if (ms) {
-      this.timer = setTimeout(function(){
-        done(new Error('timeout of ' + ms + 'ms exceeded'));
-        self.timedOut = true;
-      }, ms);
-    }
-  }
-
-  // called multiple times
-  function multiple(err) {
-    if (emitted) return;
-    emitted = true;
-    self.emit('error', err || new Error('done() called multiple times'));
-  }
-
-  // finished
-  function done(err) {
-    if (self.timedOut) return;
-    if (finished) return multiple(err);
-    self.clearTimeout();
-    self.duration = new Date - start;
-    finished = true;
-    fn(err);
-  }
-
-  // for .resetTimeout()
-  this.callback = done;
-
-  // async
-  if (this.async) {
-    try {
-      this.fn.call(ctx, function(err){
-        if (err instanceof Error) return done(err);
-        if (null != err) return done(new Error('done() invoked with non-Error: ' + err));
-        done();
-      });
-    } catch (err) {
-      done(err);
-    }
-    return;
-  }
-  
-  // sync
-  try {
-    if (!this.pending) this.fn.call(ctx);
-    this.duration = new Date - start;
-    fn();
-  } catch (err) {
-    fn(err);
-  }
-};
-
-}); // module: runnable.js
-
-require.register("runner.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var EventEmitter = require('browser/events').EventEmitter
-  , debug = require('browser/debug')('mocha:runner')
-  , Test = require('./test')
-  , utils = require('./utils')
-  , filter = utils.filter
-  , keys = utils.keys
-  , noop = function(){};
-
-/**
- * Expose `Runner`.
- */
-
-module.exports = Runner;
-
-/**
- * Initialize a `Runner` for the given `suite`.
- *
- * Events:
- *
- *   - `start`  execution started
- *   - `end`  execution complete
- *   - `suite`  (suite) test suite execution started
- *   - `suite end`  (suite) all tests (and sub-suites) have finished
- *   - `test`  (test) test execution started
- *   - `test end`  (test) test completed
- *   - `hook`  (hook) hook execution started
- *   - `hook end`  (hook) hook complete
- *   - `pass`  (test) test passed
- *   - `fail`  (test, err) test failed
- *
- * @api public
- */
-
-function Runner(suite) {
-  var self = this;
-  this._globals = [];
-  this.suite = suite;
-  this.total = suite.total();
-  this.failures = 0;
-  this.on('test end', function(test){ self.checkGlobals(test); });
-  this.on('hook end', function(hook){ self.checkGlobals(hook); });
-  this.grep(/.*/);
-  this.globals(utils.keys(global).concat(['errno']));
-}
-
-/**
- * Inherit from `EventEmitter.prototype`.
- */
-
-Runner.prototype = new EventEmitter;
-Runner.prototype.constructor = Runner;
-
-
-/**
- * Run tests with full titles matching `re`. Updates runner.total
- * with number of tests matched.
- *
- * @param {RegExp} re
- * @param {Boolean} invert
- * @return {Runner} for chaining
- * @api public
- */
-
-Runner.prototype.grep = function(re, invert){
-  debug('grep %s', re);
-  this._grep = re;
-  this._invert = invert;
-  this.total = this.grepTotal(this.suite);
-  return this;
-};
-
-/**
- * Returns the number of tests matching the grep search for the
- * given suite.
- *
- * @param {Suite} suite
- * @return {Number}
- * @api public
- */
-
-Runner.prototype.grepTotal = function(suite) {
-  var self = this;
-  var total = 0;
-
-  suite.eachTest(function(test){
-    var match = self._grep.test(test.fullTitle());
-    if (self._invert) match = !match;
-    if (match) total++;
-  });
-
-  return total;
-};
-
-/**
- * Allow the given `arr` of globals.
- *
- * @param {Array} arr
- * @return {Runner} for chaining
- * @api public
- */
-
-Runner.prototype.globals = function(arr){
-  if (0 == arguments.length) return this._globals;
-  debug('globals %j', arr);
-  utils.forEach(arr, function(arr){
-    this._globals.push(arr);
-  }, this);
-  return this;
-};
-
-/**
- * Check for global variable leaks.
- *
- * @api private
- */
-
-Runner.prototype.checkGlobals = function(test){
-  if (this.ignoreLeaks) return;
-  var leaks = filterLeaks(this._globals);
-
-  this._globals = this._globals.concat(leaks);
-
-  if (leaks.length > 1) {
-    this.fail(test, new Error('global leaks detected: ' + leaks.join(', ') + ''));
-  } else if (leaks.length) {
-    this.fail(test, new Error('global leak detected: ' + leaks[0]));
-  }
-};
-
-/**
- * Fail the given `test`.
- *
- * @param {Test} test
- * @param {Error} err
- * @api private
- */
-
-Runner.prototype.fail = function(test, err){
-  ++this.failures;
-  test.state = 'failed';
-  if ('string' == typeof err) {
-    err = new Error('the string "' + err + '" was thrown, throw an Error :)');
-  }
-  this.emit('fail', test, err);
-};
-
-/**
- * Fail the given `hook` with `err`.
- *
- * Hook failures (currently) hard-end due
- * to that fact that a failing hook will
- * surely cause subsequent tests to fail,
- * causing jumbled reporting.
- *
- * @param {Hook} hook
- * @param {Error} err
- * @api private
- */
-
-Runner.prototype.failHook = function(hook, err){
-  this.fail(hook, err);
-  this.emit('end');
-};
-
-/**
- * Run hook `name` callbacks and then invoke `fn()`.
- *
- * @param {String} name
- * @param {Function} function
- * @api private
- */
-
-Runner.prototype.hook = function(name, fn){
-  var suite = this.suite
-    , hooks = suite['_' + name]
-    , ms = suite._timeout
-    , self = this
-    , timer;
-
-  function next(i) {
-    var hook = hooks[i];
-    if (!hook) return fn();
-    self.currentRunnable = hook;
-
-    self.emit('hook', hook);
-
-    hook.on('error', function(err){
-      self.failHook(hook, err);
-    });
-
-    hook.run(function(err){
-      hook.removeAllListeners('error');
-      var testError = hook.error();
-      if (testError) self.fail(self.test, testError);
-      if (err) return self.failHook(hook, err);
-      self.emit('hook end', hook);
-      next(++i);
-    });
-  }
-
-  process.nextTick(function(){
-    next(0);
-  });
-};
-
-/**
- * Run hook `name` for the given array of `suites`
- * in order, and callback `fn(err)`.
- *
- * @param {String} name
- * @param {Array} suites
- * @param {Function} fn
- * @api private
- */
-
-Runner.prototype.hooks = function(name, suites, fn){
-  var self = this
-    , orig = this.suite;
-
-  function next(suite) {
-    self.suite = suite;
-
-    if (!suite) {
-      self.suite = orig;
-      return fn();
-    }
-
-    self.hook(name, function(err){
-      if (err) {
-        self.suite = orig;
-        return fn(err);
-      }
-
-      next(suites.pop());
-    });
-  }
-
-  next(suites.pop());
-};
-
-/**
- * Run hooks from the top level down.
- *
- * @param {String} name
- * @param {Function} fn
- * @api private
- */
-
-Runner.prototype.hookUp = function(name, fn){
-  var suites = [this.suite].concat(this.parents()).reverse();
-  this.hooks(name, suites, fn);
-};
-
-/**
- * Run hooks from the bottom up.
- *
- * @param {String} name
- * @param {Function} fn
- * @api private
- */
-
-Runner.prototype.hookDown = function(name, fn){
-  var suites = [this.suite].concat(this.parents());
-  this.hooks(name, suites, fn);
-};
-
-/**
- * Return an array of parent Suites from
- * closest to furthest.
- *
- * @return {Array}
- * @api private
- */
-
-Runner.prototype.parents = function(){
-  var suite = this.suite
-    , suites = [];
-  while (suite = suite.parent) suites.push(suite);
-  return suites;
-};
-
-/**
- * Run the current test and callback `fn(err)`.
- *
- * @param {Function} fn
- * @api private
- */
-
-Runner.prototype.runTest = function(fn){
-  var test = this.test
-    , self = this;
-
-  try {
-    test.on('error', function(err){
-      self.fail(test, err);
-    });
-    test.run(fn);
-  } catch (err) {
-    fn(err);
-  }
-};
-
-/**
- * Run tests in the given `suite` and invoke
- * the callback `fn()` when complete.
- *
- * @param {Suite} suite
- * @param {Function} fn
- * @api private
- */
-
-Runner.prototype.runTests = function(suite, fn){
-  var self = this
-    , tests = suite.tests
-    , test;
-
-  function next(err) {
-    // if we bail after first err
-    if (self.failures && suite._bail) return fn();
-
-    // next test
-    test = tests.shift();
-
-    // all done
-    if (!test) return fn();
-
-    // grep
-    var match = self._grep.test(test.fullTitle());
-    if (self._invert) match = !match;
-    if (!match) return next();
-
-    // pending
-    if (test.pending) {
-      self.emit('pending', test);
-      self.emit('test end', test);
-      return next();
-    }
-
-    // execute test and hook(s)
-    self.emit('test', self.test = test);
-    self.hookDown('beforeEach', function(){
-      self.currentRunnable = self.test;
-      self.runTest(function(err){
-        test = self.test;
-
-        if (err) {
-          self.fail(test, err);
-          self.emit('test end', test);
-          return self.hookUp('afterEach', next);
-        }
-
-        test.state = 'passed';
-        self.emit('pass', test);
-        self.emit('test end', test);
-        self.hookUp('afterEach', next);
-      });
-    });
-  }
-
-  this.next = next;
-  next();
-};
-
-/**
- * Run the given `suite` and invoke the
- * callback `fn()` when complete.
- *
- * @param {Suite} suite
- * @param {Function} fn
- * @api private
- */
-
-Runner.prototype.runSuite = function(suite, fn){
-  var total = this.grepTotal(suite)
-    , self = this
-    , i = 0;
-
-  debug('run suite %s', suite.fullTitle());
-
-  if (!total) return fn();
-
-  this.emit('suite', this.suite = suite);
-
-  function next() {
-    var curr = suite.suites[i++];
-    if (!curr) return done();
-    self.runSuite(curr, next);
-  }
-
-  function done() {
-    self.suite = suite;
-    self.hook('afterAll', function(){
-      self.emit('suite end', suite);
-      fn();
-    });
-  }
-
-  this.hook('beforeAll', function(){
-    self.runTests(suite, next);
-  });
-};
-
-/**
- * Handle uncaught exceptions.
- *
- * @param {Error} err
- * @api private
- */
-
-Runner.prototype.uncaught = function(err){
-  debug('uncaught exception %s', err.message);
-  var runnable = this.currentRunnable;
-  if (!runnable || 'failed' == runnable.state) return;
-  runnable.clearTimeout();
-  err.uncaught = true;
-  this.fail(runnable, err);
-
-  // recover from test
-  if ('test' == runnable.type) {
-    this.emit('test end', runnable);
-    this.hookUp('afterEach', this.next);
-    return;
-  }
-
-  // bail on hooks
-  this.emit('end');
-};
-
-/**
- * Run the root suite and invoke `fn(failures)`
- * on completion.
- *
- * @param {Function} fn
- * @return {Runner} for chaining
- * @api public
- */
-
-Runner.prototype.run = function(fn){
-  var self = this
-    , fn = fn || function(){};
-
-  debug('start');
-
-  // uncaught callback
-  function uncaught(err) {
-    self.uncaught(err);
-  }
-
-  // callback
-  this.on('end', function(){
-    debug('end');
-    process.removeListener('uncaughtException', uncaught);
-    fn(self.failures);
-  });
-
-  // run suites
-  this.emit('start');
-  this.runSuite(this.suite, function(){
-    debug('finished running');
-    self.emit('end');
-  });
-
-  // uncaught exception
-  process.on('uncaughtException', uncaught);
-
-  return this;
-};
-
-/**
- * Filter leaks with the given globals flagged as `ok`.
- *
- * @param {Array} ok
- * @return {Array}
- * @api private
- */
-
-function filterLeaks(ok) {
-  return filter(keys(global), function(key){
-    var matched = filter(ok, function(ok){
-      if (~ok.indexOf('*')) return 0 == key.indexOf(ok.split('*')[0]);
-      return key == ok;
-    });
-    return matched.length == 0 && (!global.navigator || 'onerror' !== key);
-  });
-}
-}); // module: runner.js
-
-require.register("suite.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var EventEmitter = require('browser/events').EventEmitter
-  , debug = require('browser/debug')('mocha:suite')
-  , utils = require('./utils')
-  , Hook = require('./hook');
-
-/**
- * Expose `Suite`.
- */
-
-exports = module.exports = Suite;
-
-/**
- * Create a new `Suite` with the given `title`
- * and parent `Suite`. When a suite with the
- * same title is already present, that suite
- * is returned to provide nicer reporter
- * and more flexible meta-testing.
- *
- * @param {Suite} parent
- * @param {String} title
- * @return {Suite}
- * @api public
- */
-
-exports.create = function(parent, title){
-  var suite = new Suite(title, parent.ctx);
-  suite.parent = parent;
-  if (parent.pending) suite.pending = true;
-  title = suite.fullTitle();
-  parent.addSuite(suite);
-  return suite;
-};
-
-/**
- * Initialize a new `Suite` with the given
- * `title` and `ctx`.
- *
- * @param {String} title
- * @param {Context} ctx
- * @api private
- */
-
-function Suite(title, ctx) {
-  this.title = title;
-  this.ctx = ctx;
-  this.suites = [];
-  this.tests = [];
-  this.pending = false;
-  this._beforeEach = [];
-  this._beforeAll = [];
-  this._afterEach = [];
-  this._afterAll = [];
-  this.root = !title;
-  this._timeout = 2000;
-  this._bail = false;
-}
-
-/**
- * Inherit from `EventEmitter.prototype`.
- */
-
-Suite.prototype = new EventEmitter;
-Suite.prototype.constructor = Suite;
-
-
-/**
- * Return a clone of this `Suite`.
- *
- * @return {Suite}
- * @api private
- */
-
-Suite.prototype.clone = function(){
-  var suite = new Suite(this.title);
-  debug('clone');
-  suite.ctx = this.ctx;
-  suite.timeout(this.timeout());
-  suite.bail(this.bail());
-  return suite;
-};
-
-/**
- * Set timeout `ms` or short-hand such as "2s".
- *
- * @param {Number|String} ms
- * @return {Suite|Number} for chaining
- * @api private
- */
-
-Suite.prototype.timeout = function(ms){
-  if (0 == arguments.length) return this._timeout;
-  if (String(ms).match(/s$/)) ms = parseFloat(ms) * 1000;
-  debug('timeout %d', ms);
-  this._timeout = parseInt(ms, 10);
-  return this;
-};
-
-/**
- * Sets whether to bail after first error.
- *
- * @parma {Boolean} bail
- * @return {Suite|Number} for chaining
- * @api private
- */
-
-Suite.prototype.bail = function(bail){
-  if (0 == arguments.length) return this._bail;
-  debug('bail %s', bail);
-  this._bail = bail;
-  return this;
-};
-
-/**
- * Run `fn(test[, done])` before running tests.
- *
- * @param {Function} fn
- * @return {Suite} for chaining
- * @api private
- */
-
-Suite.prototype.beforeAll = function(fn){
-  if (this.pending) return this;
-  var hook = new Hook('"before all" hook', fn);
-  hook.parent = this;
-  hook.timeout(this.timeout());
-  hook.ctx = this.ctx;
-  this._beforeAll.push(hook);
-  this.emit('beforeAll', hook);
-  return this;
-};
-
-/**
- * Run `fn(test[, done])` after running tests.
- *
- * @param {Function} fn
- * @return {Suite} for chaining
- * @api private
- */
-
-Suite.prototype.afterAll = function(fn){
-  if (this.pending) return this;
-  var hook = new Hook('"after all" hook', fn);
-  hook.parent = this;
-  hook.timeout(this.timeout());
-  hook.ctx = this.ctx;
-  this._afterAll.push(hook);
-  this.emit('afterAll', hook);
-  return this;
-};
-
-/**
- * Run `fn(test[, done])` before each test case.
- *
- * @param {Function} fn
- * @return {Suite} for chaining
- * @api private
- */
-
-Suite.prototype.beforeEach = function(fn){
-  if (this.pending) return this;
-  var hook = new Hook('"before each" hook', fn);
-  hook.parent = this;
-  hook.timeout(this.timeout());
-  hook.ctx = this.ctx;
-  this._beforeEach.push(hook);
-  this.emit('beforeEach', hook);
-  return this;
-};
-
-/**
- * Run `fn(test[, done])` after each test case.
- *
- * @param {Function} fn
- * @return {Suite} for chaining
- * @api private
- */
-
-Suite.prototype.afterEach = function(fn){
-  if (this.pending) return this;
-  var hook = new Hook('"after each" hook', fn);
-  hook.parent = this;
-  hook.timeout(this.timeout());
-  hook.ctx = this.ctx;
-  this._afterEach.push(hook);
-  this.emit('afterEach', hook);
-  return this;
-};
-
-/**
- * Add a test `suite`.
- *
- * @param {Suite} suite
- * @return {Suite} for chaining
- * @api private
- */
-
-Suite.prototype.addSuite = function(suite){
-  suite.parent = this;
-  suite.timeout(this.timeout());
-  suite.bail(this.bail());
-  this.suites.push(suite);
-  this.emit('suite', suite);
-  return this;
-};
-
-/**
- * Add a `test` to this suite.
- *
- * @param {Test} test
- * @return {Suite} for chaining
- * @api private
- */
-
-Suite.prototype.addTest = function(test){
-  test.parent = this;
-  test.timeout(this.timeout());
-  test.ctx = this.ctx;
-  this.tests.push(test);
-  this.emit('test', test);
-  return this;
-};
-
-/**
- * Return the full title generated by recursively
- * concatenating the parent's full title.
- *
- * @return {String}
- * @api public
- */
-
-Suite.prototype.fullTitle = function(){
-  if (this.parent) {
-    var full = this.parent.fullTitle();
-    if (full) return full + ' ' + this.title;
-  }
-  return this.title;
-};
-
-/**
- * Return the total number of tests.
- *
- * @return {Number}
- * @api public
- */
-
-Suite.prototype.total = function(){
-  return utils.reduce(this.suites, function(sum, suite){
-    return sum + suite.total();
-  }, 0) + this.tests.length;
-};
-
-/**
- * Iterates through each suite recursively to find
- * all tests. Applies a function in the format
- * `fn(test)`.
- *
- * @param {Function} fn
- * @return {Suite}
- * @api private
- */
-
-Suite.prototype.eachTest = function(fn){
-  utils.forEach(this.tests, fn);
-  utils.forEach(this.suites, function(suite){
-    suite.eachTest(fn);
-  });
-  return this;
-};
-
-}); // module: suite.js
-
-require.register("test.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var Runnable = require('./runnable');
-
-/**
- * Expose `Test`.
- */
-
-module.exports = Test;
-
-/**
- * Initialize a new `Test` with the given `title` and callback `fn`.
- *
- * @param {String} title
- * @param {Function} fn
- * @api private
- */
-
-function Test(title, fn) {
-  Runnable.call(this, title, fn);
-  this.pending = !fn;
-  this.type = 'test';
-}
-
-/**
- * Inherit from `Runnable.prototype`.
- */
-
-Test.prototype = new Runnable;
-Test.prototype.constructor = Test;
-
-
-}); // module: test.js
-
-require.register("utils.js", function(module, exports, require){
-
-/**
- * Module dependencies.
- */
-
-var fs = require('browser/fs')
-  , path = require('browser/path')
-  , join = path.join
-  , debug = require('browser/debug')('mocha:watch');
-
-/**
- * Ignored directories.
- */
-
-var ignore = ['node_modules', '.git'];
-
-/**
- * Escape special characters in the given string of html.
- *
- * @param  {String} html
- * @return {String}
- * @api private
- */
-
-exports.escape = function(html) {
-  return String(html)
-    .replace(/&/g, '&amp;')
-    .replace(/"/g, '&quot;')
-    .replace(/</g, '&lt;')
-    .replace(/>/g, '&gt;');
-};
-
-/**
- * Array#forEach (<=IE8)
- *
- * @param {Array} array
- * @param {Function} fn
- * @param {Object} scope
- * @api private
- */
-
-exports.forEach = function(arr, fn, scope) {
-  for (var i = 0, l = arr.length; i < l; i++)
-    fn.call(scope, arr[i], i);
-};
-
-/**
- * Array#indexOf (<=IE8)
- *
- * @parma {Array} arr
- * @param {Object} obj to find index of
- * @param {Number} start
- * @api private
- */
-
-exports.indexOf = function (arr, obj, start) {
-  for (var i = start || 0, l = arr.length; i < l; i++) {
-    if (arr[i] === obj)
-      return i;
-  }
-  return -1;
-};
-
-/**
- * Array#reduce (<=IE8)
- * 
- * @param {Array} array
- * @param {Function} fn
- * @param {Object} initial value
- * @param {Object} scope
- * @api private
- */
-
-exports.reduce = function(arr, fn, val, scope) {
-  var rval = val;
-
-  for (var i = 0, l = arr.length; i < l; i++) {
-    rval = fn.call(scope, rval, arr[i], i, arr);
-  }
-
-  return rval;
-};
-
-/**
- * Array#filter (<=IE8)
- *
- * @param {Array} array
- * @param {Function} fn
- * @param {Object} scope
- * @api private
- */
-
-exports.filter = function(arr, fn, scope) {
-  var ret = [];
-
-  for (var i = 0, l = arr.length; i < l; i++) {
-    var val = arr[i];
-    if (fn.call(scope, val, i, arr))
-      ret.push(val);
-  }
-
-  return ret;
-};
-
-/**
- * Object.keys (<=IE8)
- *
- * @param {Object} obj
- * @return {Array} keys
- * @api private
- */
-
-exports.keys = Object.keys || function(obj) {
-  var keys = []
-    , has = Object.prototype.hasOwnProperty // for `window` on <=IE8
-
-  for (var key in obj) {
-    if (has.call(obj, key)) {
-      keys.push(key);
-    }
-  }
-
-  return keys;
-};
-
-/**
- * Watch the given `files` for changes
- * and invoke `fn(file)` on modification.
- *
- * @param {Array} files
- * @param {Function} fn
- * @api private
- */
-
-exports.watch = function(files, fn){
-  var options = { interval: 100 };
-  files.forEach(function(file){
-    debug('file %s', file);
-    fs.watchFile(file, options, function(curr, prev){
-      if (prev.mtime < curr.mtime) fn(file);
-    });
-  });
-};
-
-/**
- * Ignored files.
- */
-
-function ignored(path){
-  return !~ignore.indexOf(path);
-}
-
-/**
- * Lookup files in the given `dir`.
- *
- * @return {Array}
- * @api private
- */
-
-exports.files = function(dir, ret){
-  ret = ret || [];
-
-  fs.readdirSync(dir)
-  .filter(ignored)
-  .forEach(function(path){
-    path = join(dir, path);
-    if (fs.statSync(path).isDirectory()) {
-      exports.files(path, ret);
-    } else if (path.match(/\.(js|coffee)$/)) {
-      ret.push(path);
-    }
-  });
-
-  return ret;
-};
-
-/**
- * Compute a slug from the given `str`.
- *
- * @param {String} str
- * @return {String}
- * @api private
- */
-
-exports.slug = function(str){
-  return str
-    .toLowerCase()
-    .replace(/ +/g, '-')
-    .replace(/[^-\w]/g, '');
-};
-
-/**
- * Strip the function definition from `str`,
- * and re-indent for pre whitespace.
- */
-
-exports.clean = function(str) {
-  str = str
-    .replace(/^function *\(.*\) *{/, '')
-    .replace(/\s+\}$/, '');
-
-  var spaces = str.match(/^\n?( *)/)[1].length
-    , re = new RegExp('^ {' + spaces + '}', 'gm');
-
-  str = str.replace(re, '');
-
-  return exports.trim(str);
-};
-
-/**
- * Escape regular expression characters in `str`.
- *
- * @param {String} str
- * @return {String}
- * @api private
- */
-
-exports.escapeRegexp = function(str){
-  return str.replace(/[-\\^$*+?.()|[\]{}]/g, "\\$&");
-};
-
-/**
- * Trim the given `str`.
- *
- * @param {String} str
- * @return {String}
- * @api private
- */
-
-exports.trim = function(str){
-  return str.replace(/^\s+|\s+$/g, '');
-};
-}); // module: utils.js
-/**
- * Node shims.
- *
- * These are meant only to allow
- * mocha.js to run untouched, not
- * to allow running node code in
- * the browser.
- */
-
-process = {};
-process.exit = function(status){};
-process.stdout = {};
-global = window;
-
-/**
- * next tick implementation.
- */
-
-process.nextTick = (function(){
-  // postMessage behaves badly on IE8
-  if (window.ActiveXObject || !window.postMessage) {
-    return function(fn){ fn() };
-  }
-
-  // based on setZeroTimeout by David Baron
-  // - http://dbaron.org/log/20100309-faster-timeouts
-  var timeouts = []
-    , name = 'mocha-zero-timeout'
-
-  window.addEventListener('message', function(e){
-    if (e.source == window && e.data == name) {
-      if (e.stopPropagation) e.stopPropagation();
-      if (timeouts.length) timeouts.shift()();
-    }
-  }, true);
-
-  return function(fn){
-    timeouts.push(fn);
-    window.postMessage(name, '*');
-  }
-})();
-
-/**
- * Remove uncaughtException listener.
- */
-
-process.removeListener = function(e){
-  if ('uncaughtException' == e) {
-    window.onerror = null;
-  }
-};
-
-/**
- * Implements uncaughtException listener.
- */
-
-process.on = function(e, fn){
-  if ('uncaughtException' == e) {
-    window.onerror = fn;
-  }
-};
-
-/**
- * Expose mocha.
- */
-
-window.mocha = require('mocha');
-
-// boot
-;(function(){
-  var utils = mocha.utils
-    , options = {}
-
-  mocha.suite = new mocha.Suite('', new mocha.Context());
-
-  /**
-   * Highlight the given string of `js`.
-   */
-
-  function highlight(js) {
-    return js
-      .replace(/</g, '&lt;')
-      .replace(/>/g, '&gt;')
-      .replace(/\/\/(.*)/gm, '<span class="comment">//$1</span>')
-      .replace(/('.*?')/gm, '<span class="string">$1</span>')
-      .replace(/(\d+\.\d+)/gm, '<span class="number">$1</span>')
-      .replace(/(\d+)/gm, '<span class="number">$1</span>')
-      .replace(/\bnew *(\w+)/gm, '<span class="keyword">new</span> <span class="init">$1</span>')
-      .replace(/\b(function|new|throw|return|var|if|else)\b/gm, '<span class="keyword">$1</span>')
-  }
-
-  /**
-   * Highlight code contents.
-   */
-
-  function highlightCode() {
-    var code = document.getElementsByTagName('code');
-    for (var i = 0, len = code.length; i < len; ++i) {
-      code[i].innerHTML = highlight(code[i].innerHTML);
-    }
-  }
-
-  /**
-   * Parse the given `qs`.
-   */
-
-  function parse(qs) {
-    return utils.reduce(qs.replace('?', '').split('&'), function(obj, pair){
-      var i = pair.indexOf('=')
-        , key = pair.slice(0, i)
-        , val = pair.slice(++i);
-
-      obj[key] = decodeURIComponent(val);
-      return obj;
-    }, {});
-  }
-
-  /**
-   * Setup mocha with the given setting options.
-   */
-
-  mocha.setup = function(opts){
-    if ('string' === typeof opts) options.ui = opts;
-    else options = opts;
-
-    ui = mocha.interfaces[options.ui];
-    if (!ui) throw new Error('invalid mocha interface "' + ui + '"');
-    if (options.timeout) mocha.suite.timeout(options.timeout);
-    ui(mocha.suite);
-    mocha.suite.emit('pre-require', window);
-  };
-
-  /**
-   * Run mocha, returning the Runner.
-   */
-
-  mocha.run = function(fn){
-    mocha.suite.emit('run');
-    var runner = new mocha.Runner(mocha.suite);
-    var Reporter = options.reporter || mocha.reporters.HTML;
-    var reporter = new Reporter(runner);
-    var query = parse(window.location.search || "");
-    if (query.grep) runner.grep(new RegExp(query.grep));
-    if (options.ignoreLeaks) runner.ignoreLeaks = true;
-    if (options.globals) runner.globals(options.globals);
-    runner.globals(['location']);
-    runner.on('end', highlightCode);
-    return runner.run(fn);
-  };
-})();
-})();
\ No newline at end of file

=== added symlink 'test/assets/mocha.js'
=== target is '../../node_modules/mocha/mocha.js'
=== modified file 'test/index.html'
--- test/index.html	2012-09-07 14:31:54 +0000
+++ test/index.html	2012-09-10 08:45:43 +0000
@@ -1,6 +1,7 @@
 <html>
 
 <head>
+  <meta charset="utf-8">
   <link rel="stylesheet" href="assets/mocha.css">
   <script src="../app/assets/javascripts/yui/yui/yui.js"></script>
   <script src="../app/modules.js"></script>
@@ -30,7 +31,8 @@
             if (!m || !resource.fullpath) {
               continue
             }
-            resource.fullpath = resource.fullpath.replace('/', '../app/', 1);
+            // resource.fullpath = resource.fullpath.replace('/\//', '../app/', 1);
+            resource.fullpath = '../app/' + resource.fullpath;
          }
      }
      console.log("global config", GlobalConfig)

=== modified file 'test/test_app.js'
--- test/test_app.js	2012-09-07 15:58:58 +0000
+++ test/test_app.js	2012-09-10 08:45:43 +0000
@@ -1,6 +1,8 @@
+"use strict";
+
 function injectData(app, data) {
-    var data = data || {"result": [["service", "add", {"charm": "cs:precise/wordpress-6", "id": "wordpress", "exposed": false}], ["service", "add", {"charm": "cs:precise/mysql-6", "id": "mysql"}], ["relation", "add", {"interface": "reversenginx", "scope": "global", "endpoints": [["wordpress", {"role": "peer", "name": "loadbalancer"}]], "id": "relation-0000000000"}], ["relation", "add", {"interface": "mysql", "scope": "global", "endpoints": [["mysql", {"role": "server", "name": "db"}], ["wordpress", {"role": "client", "name": "db"}]], "id": "relation-0000000001"}], ["machine", "add", {"agent-state": "running", "instance-state": "running", "id": 0, "instance-id": "local", "dns-name": "localhost"}], ["unit", "add", {"machine": 0, "agent-state": "started", "public-address": "192.168.122.113", "id": "wordpress/0"}], ["unit", "add", {"machine": 0, "agent-state": "started", "public-address": "192.168.122.222", "id": "mysql/0"}]], "op": "delta"};
-    app.env.dispatch_result(data);
+    var d = data || {"result": [["service", "add", {"charm": "cs:precise/wordpress-6", "id": "wordpress", "exposed": false}], ["service", "add", {"charm": "cs:precise/mysql-6", "id": "mysql"}], ["relation", "add", {"interface": "reversenginx", "scope": "global", "endpoints": [["wordpress", {"role": "peer", "name": "loadbalancer"}]], "id": "relation-0000000000"}], ["relation", "add", {"interface": "mysql", "scope": "global", "endpoints": [["mysql", {"role": "server", "name": "db"}], ["wordpress", {"role": "client", "name": "db"}]], "id": "relation-0000000001"}], ["machine", "add", {"agent-state": "running", "instance-state": "running", "id": 0, "instance-id": "local", "dns-name": "localhost"}], ["unit", "add", {"machine": 0, "agent-state": "started", "public-address": "192.168.122.113", "id": "wordpress/0"}], ["unit", "add", {"machine": 0, "agent-state": "started", "public-address": "192.168.122.222", "id": "mysql/0"}]], "op": "delta"};
+    app.env.dispatch_result(d);
     return app;
 }
 
@@ -18,13 +20,13 @@
         });
 
   });
-             
+
   after(function(done) {
       var active_view = app.get("activeView");
       if (active_view) {
           active_view.destroy({remove: true});
       } else {
-          Y.one(app.get("container")).setHTML("");          
+          Y.one(app.get("container")).setHTML("");
       }
       done();
   });
@@ -35,11 +37,11 @@
       container.getAttribute("class").should.include("container");
   });
 
-  it("should be able to render the environment view with default data", 
+  it("should be able to render the environment view with default data",
      function() {
        var container = app.get("container");
        app.showView("environment", {domain_models: app.db});
        container.one("svg").should.not.equal(null);
   });
 
-});
\ No newline at end of file
+});

=== modified file 'test/test_env.js'
--- test/test_env.js	2012-08-22 16:18:39 +0000
+++ test/test_env.js	2012-09-07 14:59:56 +0000
@@ -1,3 +1,4 @@
+"use strict";
 
 // from nodejs runner
 // YUI = require("yui").YUI,
@@ -5,36 +6,36 @@
 
 
 (function () {
-    
+
 var Y;
 var SocketStub = function () {
     this.messages = [];
 
     this.close = function() {
-	console.log('close stub');
-	this.messages = []
+        console.log('close stub');
+        this.messages = [];
     };
 
     this.transient_close = function() {
-	this.onclose();
+        this.onclose();
     };
 
     this.open = function() {
-	this.onopen();
+        this.onopen();
     };
 
     this.msg = function(m) {
-	console.log("serializing env msg", m);
-	this.onmessage({'data': Y.JSON.stringify(m)});
+        console.log("serializing env msg", m);
+        this.onmessage({'data': Y.JSON.stringify(m)});
     };
 
     this.last_message = function(m) {
-	return this.messages[this.messages.length-1];
+        return this.messages[this.messages.length-1];
     };
 
     this.send = function(m) {
-	console.log('socket send', m);
-	this.messages.push(Y.JSON.parse(m));
+        console.log('socket send', m);
+        this.messages.push(Y.JSON.parse(m));
     };
 
     this.onclose = function() {};
@@ -42,60 +43,60 @@
     this.onopen = function() {};
 
 };
-    
+
 describe("Juju environment", function() {
     var juju, conn, env, msg;
 
     before(function (done) {
-	Y = YUI(GlobalConfig).use(
-	    "base", "node", "json-parse", "juju-env",
-	    function (Y) {
-		conn = new SocketStub();
-		juju = Y.namespace("juju");
-		env = new juju.Environment({conn: conn});
-		env.connect();
-		conn.open();
-		done();
-	    });
-    })
-  
+        Y = YUI(GlobalConfig).use(
+            "base", "node", "json-parse", "juju-env",
+            function (Y) {
+                conn = new SocketStub();
+                juju = Y.namespace("juju");
+                env = new juju.Environment({conn: conn});
+                env.connect();
+                conn.open();
+                done();
+            });
+    });
+
     after(function(done)  {
-	env.destroy();
-	done();
+        env.destroy();
+        done();
     });
 
     it("can deploy a service", function(done) {
-	env.deploy('precise/mysql');
-	msg = conn.last_message();
-	msg.op.should.equal('deploy');
-	msg.charm_url.should.equal('precise/mysql');
-	done();
+        env.deploy('precise/mysql');
+        msg = conn.last_message();
+        msg.op.should.equal('deploy');
+        msg.charm_url.should.equal('precise/mysql');
+        done();
     });
 
     it("can add a unit", function(done) {
-	env.add_unit('mysql', 3);
-	msg = conn.last_message();
-	msg.op.should.equal('add_unit');
-	msg.service_name.should.equal('mysql');
-	msg.num_units.should.equal(3);
-	done();
+        env.add_unit('mysql', 3);
+        msg = conn.last_message();
+        msg.op.should.equal('add_unit');
+        msg.service_name.should.equal('mysql');
+        msg.num_units.should.equal(3);
+        done();
     });
 
     it("can accept a callback on its methods", function(done) {
-	env.get_charm('cs:precise/mysql', function(result) {
-	    console.log('invoked', result);
-	    result.op.should.equal('get_charm')
-	    result.result.id.should.equal('cs:precise/mysql');
-	    done();
-	});
+        env.get_charm('cs:precise/mysql', function(result) {
+            console.log('invoked', result);
+            result.op.should.equal('get_charm');
+            result.result.id.should.equal('cs:precise/mysql');
+            done();
+        });
 
-	msg = conn.last_message()
-	console.log('msg', msg);
-	conn.msg({
-	    'op': 'get_charm',
-	    'request_id': msg.request_id,
-	    'result': {'id': 'cs:precise/mysql'}});
+        msg = conn.last_message();
+        console.log('msg', msg);
+        conn.msg({
+            'op': 'get_charm',
+            'request_id': msg.request_id,
+            'result': {'id': 'cs:precise/mysql'}});
     });
 
-})
+});
 })();

=== modified file 'test/test_model.js'
--- test/test_model.js	2012-09-01 19:09:39 +0000
+++ test/test_model.js	2012-09-07 20:19:19 +0000
@@ -1,5 +1,7 @@
+"use strict";
+
 (function () {
- 
+
 
 describe("juju models", function() {
     var Y, models;
@@ -10,8 +12,8 @@
             done();
         });
     });
- 
- 
+
+
     it("must be able to create charm", function() {
         var charm = new models.Charm({id: "cs:precise/mysql-6"});
         charm.get("id").should.equal("cs:precise/mysql-6");
@@ -35,8 +37,8 @@
            names[1].should.equal("logger");
        });
 
-             
-    it("service unit list should be able to get units of a given service", 
+
+    it("service unit list should be able to get units of a given service",
        function() {
         var sl = new models.ServiceList();
         var sul = new models.ServiceUnitList();
@@ -55,19 +57,42 @@
            wp1 = new models.ServiceUnit({id:"wordpress/1"});
         sul.add([wp0, wp1]);
         wp0.get("service").should.equal("wordpress");
-       
+
        sul.get_units_for_service(mysql, true).getAttrs(["id"]).id.should.eql(
            ["mysql/0", "mysql/1"]);
        sul.get_units_for_service(wordpress, true).getAttrs(
            ["id"]).id.should.eql(["wordpress/0", "wordpress/1"]);
     });
 
-    it("service units should get service from unit name when missing", 
+    it("service unit list should be able to aggregate unit statuses",
+       function() {
+        var sl = new models.ServiceList();
+        var sul = new models.ServiceUnitList();
+        var mysql = new models.Service({id: "mysql"});
+        var wordpress = new models.Service({id: "wordpress"});
+        sl.add([mysql, wordpress]);
+
+        var my0 = new models.ServiceUnit({id:"mysql/0", agent_state: 'pending'}),
+           my1 = new models.ServiceUnit({id:"mysql/1", agent_state: 'pending'});
+
+        sul.add([my0, my1]);
+
+        var wp0 = new models.ServiceUnit({id:"wordpress/0", agent_state: 'pending'}),
+           wp1 = new models.ServiceUnit({id:"wordpress/1", agent_state: 'error'});
+        sul.add([wp0, wp1]);
+
+        sul.get_informative_states_for_service(mysql).should.eql(
+           {'pending': 2});
+        sul.get_informative_states_for_service(wordpress).should.eql(
+           {'pending': 1, 'error': 1});
+    });
+
+    it("service units should get service from unit name when missing",
        function() {
            var service_unit = new models.ServiceUnit({id: "mysql/0"});
            var service = service_unit.get("service");
            service.should.equal("mysql");
        });
-             
+
     });
 })();

